
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;
    if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;



/* Line 189 of yacc.c  */
#line 568 "cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     LOG = 282,
     SYSLOG = 283,
     ALL = 284,
     DEBUG = 285,
     TRACE = 286,
     INFO = 287,
     REMOTE = 288,
     WARNING = 289,
     ERROR = 290,
     AUTH = 291,
     FATAL = 292,
     BUG = 293,
     STDERR = 294,
     SOFT = 295,
     TIMEFORMAT = 296,
     ISO = 297,
     SHORT = 298,
     LONG = 299,
     BASE = 300,
     NAME = 301,
     CONFIRM = 302,
     UNDO = 303,
     CHECK = 304,
     TIMEOUT = 305,
     CONFIGURE = 306,
     DOWN = 307,
     KERNEL = 308,
     PERSIST = 309,
     SCAN = 310,
     TIME = 311,
     LEARN = 312,
     DEVICE = 313,
     ROUTES = 314,
     KRT_SOURCE = 315,
     KRT_METRIC = 316,
     ASYNC = 317,
     TABLE = 318,
     KRT_PREFSRC = 319,
     KRT_REALM = 320,
     ROUTER = 321,
     ID = 322,
     PROTOCOL = 323,
     TEMPLATE = 324,
     PREFERENCE = 325,
     DISABLED = 326,
     DIRECT = 327,
     INTERFACE = 328,
     IMPORT = 329,
     EXPORT = 330,
     FILTER = 331,
     NONE = 332,
     STATES = 333,
     FILTERS = 334,
     RECEIVE = 335,
     LIMIT = 336,
     ACTION = 337,
     WARN = 338,
     BLOCK = 339,
     RESTART = 340,
     DISABLE = 341,
     KEEP = 342,
     FILTERED = 343,
     PASSWORD = 344,
     FROM = 345,
     PASSIVE = 346,
     TO = 347,
     EVENTS = 348,
     PACKETS = 349,
     PROTOCOLS = 350,
     INTERFACES = 351,
     PRIMARY = 352,
     STATS = 353,
     COUNT = 354,
     FOR = 355,
     COMMANDS = 356,
     PREEXPORT = 357,
     GENERATE = 358,
     ROA = 359,
     MAX = 360,
     FLUSH = 361,
     LISTEN = 362,
     BGP = 363,
     V6ONLY = 364,
     DUAL = 365,
     ADDRESS = 366,
     PORT = 367,
     PASSWORDS = 368,
     DESCRIPTION = 369,
     SORTED = 370,
     RELOAD = 371,
     IN = 372,
     OUT = 373,
     MRTDUMP = 374,
     MESSAGES = 375,
     RESTRICT = 376,
     MEMORY = 377,
     IGP_METRIC = 378,
     SHOW = 379,
     STATUS = 380,
     SUMMARY = 381,
     ROUTE = 382,
     SYMBOLS = 383,
     ADD = 384,
     DELETE = 385,
     DUMP = 386,
     RESOURCES = 387,
     SOCKETS = 388,
     NEIGHBORS = 389,
     ATTRIBUTES = 390,
     ECHO = 391,
     ENABLE = 392,
     FUNCTION = 393,
     PRINT = 394,
     PRINTN = 395,
     UNSET = 396,
     RETURN = 397,
     ACCEPT = 398,
     REJECT = 399,
     QUITBIRD = 400,
     INT = 401,
     BOOL = 402,
     IP = 403,
     PREFIX = 404,
     PAIR = 405,
     QUAD = 406,
     EC = 407,
     SET = 408,
     STRING = 409,
     BGPMASK = 410,
     BGPPATH = 411,
     CLIST = 412,
     ECLIST = 413,
     IF = 414,
     THEN = 415,
     ELSE = 416,
     CASE = 417,
     TRUE = 418,
     FALSE = 419,
     RT = 420,
     RO = 421,
     UNKNOWN = 422,
     GENERIC = 423,
     GW = 424,
     NET = 425,
     MASK = 426,
     PROTO = 427,
     SOURCE = 428,
     SCOPE = 429,
     CAST = 430,
     DEST = 431,
     LEN = 432,
     DEFINED = 433,
     CONTAINS = 434,
     RESET = 435,
     PREPEND = 436,
     FIRST = 437,
     LAST = 438,
     MATCH = 439,
     ROA_CHECK = 440,
     EMPTY = 441,
     WHERE = 442,
     EVAL = 443,
     LOCAL = 444,
     NEIGHBOR = 445,
     AS = 446,
     HOLD = 447,
     CONNECT = 448,
     RETRY = 449,
     KEEPALIVE = 450,
     MULTIHOP = 451,
     STARTUP = 452,
     VIA = 453,
     NEXT = 454,
     HOP = 455,
     SELF = 456,
     DEFAULT = 457,
     PATH = 458,
     METRIC = 459,
     START = 460,
     DELAY = 461,
     FORGET = 462,
     WAIT = 463,
     AFTER = 464,
     BGP_PATH = 465,
     BGP_LOCAL_PREF = 466,
     BGP_MED = 467,
     BGP_ORIGIN = 468,
     BGP_NEXT_HOP = 469,
     BGP_ATOMIC_AGGR = 470,
     BGP_AGGREGATOR = 471,
     BGP_COMMUNITY = 472,
     BGP_EXT_COMMUNITY = 473,
     RR = 474,
     RS = 475,
     CLIENT = 476,
     CLUSTER = 477,
     AS4 = 478,
     ADVERTISE = 479,
     IPV4 = 480,
     CAPABILITIES = 481,
     PREFER = 482,
     OLDER = 483,
     MISSING = 484,
     LLADDR = 485,
     DROP = 486,
     IGNORE = 487,
     REFRESH = 488,
     INTERPRET = 489,
     COMMUNITIES = 490,
     BGP_ORIGINATOR_ID = 491,
     BGP_CLUSTER_LIST = 492,
     IGP = 493,
     GATEWAY = 494,
     RECURSIVE = 495,
     MED = 496,
     TTL = 497,
     SECURITY = 498,
     DETERMINISTIC = 499,
     SECONDARY = 500,
     OSPF = 501,
     AREA = 502,
     OSPF_METRIC1 = 503,
     OSPF_METRIC2 = 504,
     OSPF_TAG = 505,
     OSPF_ROUTER_ID = 506,
     RFC1583COMPAT = 507,
     STUB = 508,
     TICK = 509,
     COST = 510,
     COST2 = 511,
     RETRANSMIT = 512,
     HELLO = 513,
     TRANSMIT = 514,
     PRIORITY = 515,
     DEAD = 516,
     TYPE = 517,
     BROADCAST = 518,
     BCAST = 519,
     NONBROADCAST = 520,
     NBMA = 521,
     POINTOPOINT = 522,
     PTP = 523,
     POINTOMULTIPOINT = 524,
     PTMP = 525,
     SIMPLE = 526,
     AUTHENTICATION = 527,
     STRICT = 528,
     CRYPTOGRAPHIC = 529,
     ELIGIBLE = 530,
     POLL = 531,
     NETWORKS = 532,
     HIDDEN = 533,
     VIRTUAL = 534,
     LINK = 535,
     RX = 536,
     BUFFER = 537,
     LARGE = 538,
     NORMAL = 539,
     STUBNET = 540,
     TAG = 541,
     EXTERNAL = 542,
     LSADB = 543,
     ECMP = 544,
     WEIGHT = 545,
     NSSA = 546,
     TRANSLATOR = 547,
     STABILITY = 548,
     GLOBAL = 549,
     LSID = 550,
     INSTANCE = 551,
     REAL = 552,
     TOPOLOGY = 553,
     STATE = 554,
     PIPE = 555,
     PEER = 556,
     MODE = 557,
     OPAQUE = 558,
     TRANSPARENT = 559,
     RADV = 560,
     MIN = 561,
     RA = 562,
     INTERVAL = 563,
     MANAGED = 564,
     OTHER = 565,
     CONFIG = 566,
     MTU = 567,
     REACHABLE = 568,
     RETRANS = 569,
     TIMER = 570,
     CURRENT = 571,
     VALID = 572,
     PREFERRED = 573,
     MULT = 574,
     LIFETIME = 575,
     SKIP = 576,
     ONLINK = 577,
     AUTONOMOUS = 578,
     RDNSS = 579,
     DNSSL = 580,
     NS = 581,
     DOMAIN = 582,
     RIP = 583,
     INFINITY = 584,
     PERIOD = 585,
     GARBAGE = 586,
     MULTICAST = 587,
     QUIET = 588,
     NOLISTEN = 589,
     VERSION1 = 590,
     PLAINTEXT = 591,
     MD5 = 592,
     HONOR = 593,
     NEVER = 594,
     ALWAYS = 595,
     RIP_METRIC = 596,
     RIP_TAG = 597,
     STATIC = 598,
     PROHIBIT = 599,
     MULTIPATH = 600,
     BLACKHOLE = 601,
     UNREACHABLE = 602
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 489 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;



/* Line 214 of yacc.c  */
#line 980 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 992 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  64
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2740

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  369
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  267
/* YYNRULES -- Number of rules.  */
#define YYNRULES  828
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1543

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   602

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     359,   360,    28,    26,   365,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   362,   361,
      23,    22,    24,   366,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   367,     2,   368,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   363,     2,   364,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      49,    52,    55,    57,    59,    62,    65,    67,    69,    70,
      75,    78,    79,    81,    84,    86,    88,    92,    94,    98,
     100,   102,   104,   106,   108,   110,   112,   114,   116,   121,
     125,   127,   129,   131,   133,   136,   141,   145,   149,   153,
     158,   164,   168,   172,   177,   180,   181,   183,   184,   186,
     189,   192,   195,   199,   202,   206,   209,   213,   217,   221,
     226,   232,   234,   236,   238,   243,   244,   247,   250,   253,
     255,   257,   258,   260,   264,   268,   269,   278,   280,   285,
     287,   289,   290,   292,   296,   297,   300,   303,   306,   309,
     312,   315,   319,   323,   327,   332,   335,   339,   342,   345,
     347,   349,   351,   352,   355,   358,   361,   364,   367,   369,
     373,   377,   378,   380,   382,   385,   386,   388,   392,   394,
     398,   399,   402,   405,   409,   413,   417,   418,   422,   424,
     426,   430,   432,   436,   438,   440,   442,   444,   446,   448,
     450,   452,   456,   458,   462,   464,   466,   471,   473,   474,
     478,   483,   485,   488,   489,   495,   501,   507,   513,   518,
     522,   526,   531,   537,   539,   540,   544,   549,   554,   555,
     558,   562,   566,   570,   573,   576,   579,   582,   586,   590,
     593,   596,   598,   600,   605,   606,   610,   614,   618,   619,
     621,   623,   628,   629,   632,   635,   638,   641,   644,   647,
     650,   651,   654,   664,   674,   679,   683,   687,   691,   695,
     699,   703,   707,   712,   714,   716,   718,   719,   721,   725,
     729,   733,   737,   742,   747,   752,   757,   760,   762,   764,
     766,   768,   769,   771,   772,   777,   780,   782,   784,   786,
     788,   790,   792,   794,   796,   798,   800,   802,   804,   807,
     810,   811,   815,   817,   821,   823,   825,   827,   830,   834,
     837,   842,   843,   849,   850,   852,   854,   857,   859,   863,
     865,   867,   869,   871,   873,   875,   879,   881,   883,   885,
     887,   889,   893,   895,   901,   913,   915,   917,   919,   922,
     924,   932,   942,   950,   952,   954,   956,   960,   962,   964,
     966,   970,   972,   976,   978,   982,   986,   988,   991,   994,
    1001,  1003,  1007,  1008,  1013,  1017,  1019,  1023,  1027,  1031,
    1034,  1037,  1040,  1043,  1044,  1047,  1050,  1051,  1053,  1055,
    1057,  1059,  1061,  1063,  1065,  1069,  1073,  1075,  1077,  1083,
    1091,  1092,  1097,  1099,  1101,  1103,  1105,  1107,  1109,  1111,
    1113,  1115,  1119,  1123,  1127,  1131,  1135,  1139,  1143,  1147,
    1151,  1155,  1159,  1163,  1167,  1171,  1174,  1179,  1181,  1183,
    1185,  1187,  1190,  1193,  1197,  1201,  1208,  1212,  1216,  1220,
    1224,  1230,  1237,  1244,  1251,  1258,  1263,  1272,  1277,  1279,
    1281,  1283,  1285,  1287,  1289,  1291,  1292,  1294,  1298,  1300,
    1304,  1305,  1307,  1312,  1319,  1324,  1328,  1334,  1340,  1345,
    1352,  1356,  1359,  1365,  1371,  1380,  1389,  1398,  1407,  1410,
    1414,  1418,  1424,  1431,  1439,  1446,  1451,  1456,  1462,  1469,
    1476,  1482,  1486,  1491,  1497,  1503,  1509,  1515,  1520,  1525,
    1531,  1537,  1543,  1549,  1555,  1561,  1567,  1573,  1580,  1587,
    1596,  1603,  1610,  1616,  1621,  1627,  1632,  1638,  1643,  1649,
    1654,  1660,  1666,  1669,  1673,  1677,  1679,  1682,  1685,  1690,
    1693,  1695,  1698,  1703,  1704,  1708,  1711,  1713,  1716,  1720,
    1724,  1728,  1732,  1735,  1739,  1740,  1746,  1747,  1753,  1756,
    1759,  1761,  1766,  1768,  1770,  1771,  1775,  1778,  1781,  1784,
    1790,  1793,  1794,  1798,  1799,  1802,  1805,  1809,  1812,  1815,
    1819,  1822,  1825,  1828,  1830,  1834,  1837,  1840,  1843,  1846,
    1849,  1852,  1856,  1859,  1862,  1865,  1868,  1871,  1874,  1877,
    1880,  1884,  1888,  1891,  1895,  1898,  1902,  1906,  1911,  1914,
    1917,  1920,  1924,  1928,  1932,  1934,  1935,  1938,  1942,  1944,
    1945,  1947,  1950,  1951,  1954,  1956,  1958,  1961,  1965,  1966,
    1967,  1970,  1971,  1975,  1976,  1980,  1985,  1987,  1988,  1993,
    2000,  2007,  2014,  2022,  2029,  2037,  2043,  2044,  2047,  2051,
    2054,  2058,  2062,  2065,  2069,  2072,  2075,  2079,  2083,  2089,
    2094,  2099,  2102,  2104,  2107,  2110,  2111,  2115,  2116,  2120,
    2121,  2125,  2131,  2132,  2137,  2142,  2146,  2149,  2153,  2157,
    2161,  2165,  2170,  2174,  2177,  2178,  2182,  2183,  2187,  2191,
    2195,  2196,  2197,  2201,  2202,  2206,  2211,  2213,  2216,  2219,
    2222,  2226,  2230,  2231,  2232,  2236,  2237,  2241,  2245,  2247,
    2248,  2249,  2252,  2255,  2256,  2257,  2261,  2263,  2269,  2271,
    2272,  2273,  2276,  2279,  2280,  2281,  2285,  2287,  2293,  2295,
    2298,  2301,  2305,  2309,  2314,  2319,  2324,  2330,  2336,  2341,
    2345,  2350,  2355,  2360,  2365,  2367,  2369,  2371,  2373,  2375,
    2377,  2379,  2381,  2382,  2385,  2388,  2389,  2393,  2394,  2398,
    2399,  2403,  2406,  2410,  2414,  2420,  2426,  2430,  2433,  2437,
    2441,  2443,  2446,  2451,  2455,  2459,  2463,  2466,  2469,  2472,
    2475,  2478,  2483,  2485,  2487,  2489,  2491,  2493,  2495,  2497,
    2499,  2501,  2503,  2505,  2507,  2509,  2511,  2513,  2515,  2517,
    2519,  2521,  2523,  2525,  2527,  2529,  2531,  2533,  2535,  2537,
    2539,  2541,  2543,  2545,  2547,  2549,  2551,  2553,  2555,  2557,
    2559,  2561,  2563,  2565,  2567,  2569,  2571,  2573,  2575,  2577,
    2579,  2581,  2583,  2585,  2587,  2589,  2591,  2593,  2595,  2597,
    2599,  2602,  2605,  2608,  2611,  2614,  2617,  2619,  2622,  2625,
    2629,  2633,  2637,  2641,  2645,  2649,  2653,  2655,  2657,  2659,
    2661,  2663,  2665,  2667,  2669,  2671,  2673,  2675,  2677,  2679,
    2681,  2683,  2685,  2687,  2689,  2691,  2693,  2695,  2697
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     370,     0,    -1,   371,     3,    -1,     4,   631,    -1,    -1,
     371,   630,    -1,    15,    -1,   359,   529,   360,    -1,    19,
      -1,    33,    19,    22,   372,   361,    -1,    33,    19,    22,
      18,   361,    -1,   372,    -1,    34,    -1,    36,    -1,    35,
      -1,    37,    -1,    -1,    18,    -1,    19,    -1,    -1,    30,
      19,    -1,   375,   379,    -1,   377,    -1,   375,    -1,    29,
     372,    -1,   362,   375,    -1,    20,    -1,    20,    -1,    -1,
      38,   384,   385,   361,    -1,    57,    20,    -1,    -1,    20,
      -1,    39,   383,    -1,    50,    -1,    40,    -1,   363,   386,
     364,    -1,   387,    -1,   386,   365,   387,    -1,    41,    -1,
      42,    -1,    43,    -1,    44,    -1,    45,    -1,    46,    -1,
      47,    -1,    48,    -1,    49,    -1,   130,   106,   437,   361,
      -1,   130,    20,   361,    -1,   138,    -1,    79,    -1,    56,
      -1,    38,    -1,   389,    20,    -1,   389,    20,   372,    20,
      -1,   389,    53,    54,    -1,   389,    53,    55,    -1,    52,
     390,   361,    -1,    62,   398,   399,     3,    -1,    62,    51,
     398,   399,     3,    -1,    62,    58,     3,    -1,    62,    59,
       3,    -1,    62,    60,   398,     3,    -1,    63,     3,    -1,
      -1,    20,    -1,    -1,    61,    -1,    61,   372,    -1,   415,
      64,    -1,    65,   374,    -1,    66,    67,   372,    -1,    68,
     374,    -1,    69,    70,   374,    -1,   415,    69,    -1,    66,
      67,   372,    -1,   108,   381,   378,    -1,    64,    74,   372,
      -1,    77,    78,   406,   361,    -1,    77,    78,   101,   429,
     361,    -1,    15,    -1,    17,    -1,    18,    -1,   118,   119,
     408,   361,    -1,    -1,   408,   409,    -1,   122,   375,    -1,
     123,   372,    -1,   120,    -1,   121,    -1,    -1,   126,    -1,
      74,    19,   410,    -1,   115,    74,    19,    -1,    -1,   413,
     115,   377,   116,    15,   202,    15,   361,    -1,   412,    -1,
     412,   363,   413,   364,    -1,    79,    -1,    80,    -1,    -1,
      19,    -1,    19,   101,    19,    -1,    -1,    81,   372,    -1,
      82,   374,    -1,    41,   434,    -1,   130,   437,    -1,    85,
     418,    -1,    86,   418,    -1,    91,    92,   420,    -1,    85,
      92,   420,    -1,    86,    92,   420,    -1,    85,    98,    99,
     374,    -1,    74,   421,    -1,    77,    78,   406,    -1,   125,
      20,    -1,    87,   493,    -1,   494,    -1,    40,    -1,    88,
      -1,    -1,    93,    94,    -1,    93,    95,    -1,    93,    96,
      -1,    93,    97,    -1,   372,   419,    -1,    19,    -1,    41,
     106,   434,    -1,    41,   112,   372,    -1,    -1,    20,    -1,
     378,    -1,    20,   378,    -1,    -1,    27,    -1,   423,   425,
     424,    -1,   426,    -1,   427,   365,   426,    -1,    -1,   428,
     427,    -1,   415,    83,    -1,   430,   416,   363,    -1,   431,
     417,   361,    -1,   431,   433,   361,    -1,    -1,    84,   432,
     427,    -1,    40,    -1,    35,    -1,   363,   435,   364,    -1,
     436,    -1,   435,   365,   436,    -1,    89,    -1,    70,    -1,
      90,    -1,   107,    -1,   104,    -1,   105,    -1,    40,    -1,
      35,    -1,   363,   438,   364,    -1,   439,    -1,   438,   365,
     439,    -1,    89,    -1,   131,    -1,   124,   363,   441,   364,
      -1,   442,    -1,    -1,   442,   361,   441,    -1,   443,   363,
     444,   364,    -1,   443,    -1,   100,    20,    -1,    -1,   114,
     101,   380,   361,   444,    -1,   114,   103,   380,   361,   444,
      -1,   154,   101,   380,   361,   444,    -1,   154,   103,   380,
     361,   444,    -1,    78,   372,   361,   444,    -1,   135,   136,
       3,    -1,   135,   133,     3,    -1,   135,   106,   484,     3,
      -1,   135,   106,    40,   484,     3,    -1,    19,    -1,    -1,
     135,   107,     3,    -1,   135,   107,   137,     3,    -1,   135,
     138,   453,     3,    -1,    -1,   453,   377,    -1,   453,   111,
     378,    -1,   453,    74,    19,    -1,   453,    87,   493,    -1,
     453,   494,    -1,   453,    40,    -1,   453,   108,    -1,   453,
      99,    -1,   453,   454,    19,    -1,   453,    79,    19,    -1,
     453,   109,    -1,   453,   110,    -1,   113,    -1,    86,    -1,
     135,   115,   456,     3,    -1,    -1,   456,   457,   377,    -1,
     456,   202,    15,    -1,   456,    74,    19,    -1,    -1,   128,
      -1,   111,    -1,   135,   139,   459,     3,    -1,    -1,   459,
      74,    -1,   459,   149,    -1,   459,    87,    -1,   459,    79,
      -1,   459,    80,    -1,   459,   115,    -1,   459,    19,    -1,
      -1,    74,    19,    -1,   140,   115,   377,   116,    15,   202,
      15,   460,     3,    -1,   141,   115,   377,   116,    15,   202,
      15,   460,     3,    -1,   117,   115,   460,     3,    -1,   142,
     143,     3,    -1,   142,   144,     3,    -1,   142,   107,     3,
      -1,   142,   145,     3,    -1,   142,   146,     3,    -1,   142,
      70,     3,    -1,   142,   106,     3,    -1,   147,   472,   473,
       3,    -1,    40,    -1,    35,    -1,    15,    -1,    -1,    15,
      -1,    97,   483,     3,    -1,   148,   483,     3,    -1,    96,
     483,     3,    -1,   127,   483,     3,    -1,   127,   128,   483,
       3,    -1,   127,   129,   483,     3,    -1,    41,   483,   434,
       3,    -1,   130,   483,   437,     3,    -1,   132,     3,    -1,
      19,    -1,    40,    -1,    20,    -1,    19,    -1,    -1,    20,
      -1,    -1,    87,    19,   486,   492,    -1,   199,   529,    -1,
     157,    -1,   158,    -1,   159,    -1,   160,    -1,   161,    -1,
     162,    -1,   163,    -1,   165,    -1,   166,    -1,   167,    -1,
     168,    -1,   169,    -1,   488,   164,    -1,   488,    19,    -1,
      -1,   489,   361,   490,    -1,   489,    -1,   489,   361,   491,
      -1,   496,    -1,    19,    -1,   492,    -1,   198,   529,    -1,
     359,   491,   360,    -1,   359,   360,    -1,   490,   363,   499,
     364,    -1,    -1,   149,    19,   498,   495,   496,    -1,    -1,
     500,    -1,   535,    -1,   500,   535,    -1,   535,    -1,   363,
     499,   364,    -1,    18,    -1,   372,    -1,    17,    -1,   502,
      -1,    16,    -1,    15,    -1,   359,   529,   360,    -1,    17,
      -1,   502,    -1,    16,    -1,   529,    -1,   505,    -1,   505,
       7,   505,    -1,    28,    -1,   359,   506,   365,   506,   360,
      -1,   359,   506,   365,   506,   360,     7,   359,   505,   365,
     505,   360,    -1,   529,    -1,   176,    -1,   177,    -1,   178,
      15,    -1,   179,    -1,   359,   509,   365,   508,   365,   508,
     360,    -1,   359,   509,   365,   508,   365,   508,     7,   508,
     360,    -1,   359,   509,   365,   508,   365,    28,   360,    -1,
     507,    -1,   510,    -1,   503,    -1,   503,     7,   503,    -1,
     507,    -1,   510,    -1,   504,    -1,   504,     7,   504,    -1,
     511,    -1,   513,   365,   511,    -1,   512,    -1,   514,   365,
     512,    -1,    18,    29,    15,    -1,   515,    -1,   515,    26,
      -1,   515,    27,    -1,   515,   363,    15,   365,    15,   364,
      -1,   516,    -1,   517,   365,   516,    -1,    -1,   518,   514,
     362,   499,    -1,   518,     6,   499,    -1,   527,    -1,   359,
     529,   360,    -1,    13,   521,    14,    -1,    29,   522,    29,
      -1,    15,   521,    -1,    28,   521,    -1,   366,   521,    -1,
     519,   521,    -1,    -1,    15,   522,    -1,   366,   522,    -1,
      -1,    15,    -1,   174,    -1,   175,    -1,    20,    -1,   502,
      -1,   515,    -1,    17,    -1,   367,   513,   368,    -1,   367,
     517,   368,    -1,    16,    -1,   520,    -1,   359,   529,   365,
     529,   360,    -1,   359,   509,   365,   529,   365,   529,   360,
      -1,    -1,    19,   359,   534,   360,    -1,    19,    -1,   101,
      -1,   180,    -1,   181,    -1,   183,    -1,   184,    -1,   185,
      -1,   186,    -1,   187,    -1,   359,   529,   360,    -1,   529,
      26,   529,    -1,   529,    27,   529,    -1,   529,    28,   529,
      -1,   529,    29,   529,    -1,   529,    11,   529,    -1,   529,
      12,   529,    -1,   529,    22,   529,    -1,   529,    10,   529,
      -1,   529,    23,   529,    -1,   529,     9,   529,    -1,   529,
      24,   529,    -1,   529,     8,   529,    -1,   529,    25,   529,
      -1,    31,   529,    -1,   189,   359,   529,   360,    -1,   527,
      -1,   523,    -1,   524,    -1,    81,    -1,   525,   528,    -1,
     525,   635,    -1,   529,    32,   159,    -1,   529,    32,   188,
      -1,   529,    32,   182,   359,   529,   360,    -1,   529,    32,
     193,    -1,   529,    32,   194,    -1,    26,   197,    26,    -1,
      27,   197,    27,    -1,    27,    27,   197,    27,    27,    -1,
     192,   359,   529,   365,   529,   360,    -1,   140,   359,   529,
     365,   529,   360,    -1,   141,   359,   529,   365,   529,   360,
      -1,    87,   359,   529,   365,   529,   360,    -1,   196,   359,
      19,   360,    -1,   196,   359,    19,   365,   529,   365,   529,
     360,    -1,    19,   359,   534,   360,    -1,   156,    -1,   154,
      -1,   155,    -1,    46,    -1,   150,    -1,   151,    -1,   529,
      -1,    -1,   531,    -1,   531,   365,   532,    -1,   529,    -1,
     529,   365,   533,    -1,    -1,   533,    -1,   170,   529,   171,
     501,    -1,   170,   529,   171,   501,   172,   501,    -1,    19,
      22,   529,   361,    -1,   153,   529,   361,    -1,   525,   635,
      22,   529,   361,    -1,   525,   528,    22,   529,   361,    -1,
      81,    22,   529,   361,    -1,   152,   359,   525,   635,   360,
     361,    -1,   530,   532,   361,    -1,   526,   361,    -1,   173,
     529,   363,   518,   364,    -1,   525,   635,    32,   197,   361,
      -1,   525,   635,    32,   192,   359,   529,   360,   361,    -1,
     525,   635,    32,   140,   359,   529,   360,   361,    -1,   525,
     635,    32,   141,   359,   529,   360,   361,    -1,   525,   635,
      32,    87,   359,   529,   360,   361,    -1,   415,   119,    -1,
     536,   416,   363,    -1,   537,   417,   361,    -1,   537,   200,
     202,   372,   361,    -1,   537,   200,   375,   202,   372,   361,
      -1,   537,   201,   375,   376,   202,   372,   361,    -1,   537,
     230,   233,    78,   406,   361,    -1,   537,   230,   232,   361,
      -1,   537,   231,   232,   361,    -1,   537,   203,    67,   372,
     361,    -1,   537,   208,   203,    67,   372,   361,    -1,   537,
     204,   205,    67,   372,   361,    -1,   537,   206,    67,   372,
     361,    -1,   537,   207,   361,    -1,   537,   207,   372,   361,
      -1,   537,   210,   211,   212,   361,    -1,   537,   240,   241,
     212,   361,    -1,   537,   240,   241,   242,   361,    -1,   537,
     240,   241,   243,   361,    -1,   537,   250,    83,   361,    -1,
     537,   250,   251,   361,    -1,   537,   214,   215,   374,   361,
      -1,   537,   252,   215,   374,   361,    -1,   537,   249,   215,
     374,   361,    -1,   537,   238,   239,   374,   361,    -1,   537,
     255,   252,   374,   361,    -1,   537,   213,   223,   372,   361,
      -1,   537,   213,   222,   372,   361,    -1,   537,   184,   122,
     375,   361,    -1,   537,   216,   217,    67,   372,   361,    -1,
     537,    46,   218,    67,   372,   361,    -1,   537,    46,   219,
      67,   372,   365,   372,   361,    -1,   537,    97,   220,    46,
     374,   361,    -1,   537,   148,   138,   244,   374,   361,    -1,
     537,   148,   234,   374,   361,    -1,   537,   237,   374,   361,
      -1,   537,   235,   236,   374,   361,    -1,   537,   100,    20,
     361,    -1,   537,   138,    92,   372,   361,    -1,   537,   102,
     374,   361,    -1,   537,   245,   246,   374,   361,    -1,   537,
     256,   374,   361,    -1,   537,   249,    74,   421,   361,    -1,
     537,   253,   254,   374,   361,    -1,   415,   257,    -1,   538,
     416,   363,    -1,   539,   540,   361,    -1,   417,    -1,   263,
     374,    -1,   300,   374,    -1,   300,   374,    92,   372,    -1,
     265,   372,    -1,   542,    -1,   258,   406,    -1,   541,   363,
     543,   364,    -1,    -1,   543,   544,   361,    -1,   264,   374,
      -1,   302,    -1,   137,   374,    -1,   213,   302,   374,    -1,
     213,   266,   372,    -1,   213,   267,   372,    -1,   264,   266,
     372,    -1,   303,   374,    -1,   303,   304,   372,    -1,    -1,
     288,   545,   363,   556,   364,    -1,    -1,   298,   546,   363,
     556,   364,    -1,   296,   547,    -1,    84,   568,    -1,   551,
      -1,   548,   363,   549,   364,    -1,   548,    -1,   377,    -1,
      -1,   549,   550,   361,    -1,   289,   374,    -1,   137,   374,
      -1,   266,   372,    -1,   554,   565,   363,   552,   364,    -1,
     554,   565,    -1,    -1,   552,   553,   361,    -1,    -1,   269,
     372,    -1,   268,   372,    -1,   270,   217,   372,    -1,   219,
     372,    -1,   272,   372,    -1,   272,   110,   372,    -1,   283,
      88,    -1,   283,   282,    -1,   283,   285,    -1,   440,    -1,
     290,   291,   406,    -1,   266,   372,    -1,   269,   372,    -1,
     287,   372,    -1,   268,   372,    -1,   219,   372,    -1,   272,
     372,    -1,   272,   110,   372,    -1,   273,   274,    -1,   273,
     275,    -1,   273,   276,    -1,   273,   277,    -1,   273,   278,
      -1,   273,   279,    -1,   273,   280,    -1,   273,   281,    -1,
     308,   274,   374,    -1,   270,   217,   372,    -1,   271,   372,
      -1,   284,   276,   374,    -1,   264,   374,    -1,    60,   291,
     374,    -1,   300,   301,   372,    -1,   145,   363,   560,   364,
      -1,   283,    88,    -1,   283,   282,    -1,   283,   285,    -1,
     292,   293,   294,    -1,   292,   293,   295,    -1,   292,   293,
     372,    -1,   440,    -1,    -1,   556,   557,    -1,   558,   559,
     361,    -1,   377,    -1,    -1,   289,    -1,   297,   372,    -1,
      -1,   560,   561,    -1,   562,    -1,   563,    -1,    18,   361,
      -1,    18,   286,   361,    -1,    -1,    -1,   307,   372,    -1,
      -1,   566,   555,   361,    -1,    -1,   363,   566,   364,    -1,
     564,   427,   565,   567,    -1,    20,    -1,    -1,   135,   257,
     449,     3,    -1,   135,   257,   145,   449,   569,     3,    -1,
     135,   257,    84,   449,   569,     3,    -1,   135,   257,   309,
     449,   569,     3,    -1,   135,   257,   309,    40,   449,   569,
       3,    -1,   135,   257,   310,   449,   569,     3,    -1,   135,
     257,   310,    40,   449,   569,     3,    -1,   135,   257,   299,
     578,     3,    -1,    -1,   578,   305,    -1,   578,   258,   406,
      -1,   578,   291,    -1,   578,   273,    15,    -1,   578,   306,
     406,    -1,   578,   212,    -1,   578,    77,   406,    -1,   578,
      19,    -1,   415,   311,    -1,   579,   416,   363,    -1,   580,
     417,   361,    -1,   580,   312,    74,    19,   361,    -1,   580,
     313,   314,   361,    -1,   580,   313,   315,   361,    -1,   415,
     316,    -1,   417,    -1,    84,   594,    -1,   160,   600,    -1,
      -1,   335,   583,   606,    -1,    -1,   336,   584,   612,    -1,
      -1,   585,   582,   361,    -1,   581,   416,   363,   585,   364,
      -1,    -1,   317,   318,   319,   372,    -1,   116,   318,   319,
     372,    -1,   317,   217,   372,    -1,   320,   374,    -1,   321,
     322,   374,    -1,   291,   323,   372,    -1,   324,    67,   372,
      -1,   325,   326,   372,    -1,   327,   211,    92,   372,    -1,
     213,   331,   372,    -1,   160,   600,    -1,    -1,   335,   589,
     606,    -1,    -1,   336,   590,   612,    -1,   335,   200,   374,
      -1,   336,   200,   374,    -1,    -1,    -1,   592,   588,   361,
      -1,    -1,   363,   592,   364,    -1,   587,   427,   593,   591,
      -1,   377,    -1,   332,   374,    -1,   333,   374,    -1,   334,
     374,    -1,   328,   331,   372,    -1,   329,   331,   372,    -1,
      -1,    -1,   598,   596,   361,    -1,    -1,   363,   598,   364,
      -1,   595,   599,   597,    -1,   375,    -1,    -1,    -1,   337,
     601,    -1,   331,   613,    -1,    -1,    -1,   605,   603,   361,
      -1,   601,    -1,   363,   602,   605,   364,   604,    -1,    20,
      -1,    -1,    -1,   338,   607,    -1,   331,   613,    -1,    -1,
      -1,   611,   609,   361,    -1,   607,    -1,   363,   608,   611,
     364,   610,    -1,   372,    -1,   330,   372,    -1,   415,   339,
      -1,   614,   416,   363,    -1,   615,   417,   361,    -1,   615,
     340,   372,   361,    -1,   615,   123,   372,   361,    -1,   615,
     341,   372,   361,    -1,   615,   342,    67,   372,   361,    -1,
     615,    61,    67,   372,   361,    -1,   615,   283,   616,   361,
      -1,   615,   440,   361,    -1,   615,   349,   351,   361,    -1,
     615,   349,   201,   361,    -1,   615,   349,   350,   361,    -1,
     615,    84,   622,   361,    -1,   347,    -1,   348,    -1,    88,
      -1,   274,    -1,   343,    -1,   344,    -1,   345,    -1,   346,
      -1,    -1,   215,   372,    -1,   313,   617,    -1,    -1,   619,
     618,   361,    -1,    -1,   363,   619,   364,    -1,    -1,   621,
     427,   620,    -1,   415,   354,    -1,   623,   416,   363,    -1,
     624,   417,   361,    -1,   624,    60,   291,   374,   361,    -1,
     624,   249,    74,   421,   361,    -1,   624,   628,   361,    -1,
     138,   377,    -1,   209,   375,   376,    -1,   626,   301,   372,
      -1,   626,    -1,   627,   626,    -1,   625,   209,   375,   376,
      -1,   625,   209,    20,    -1,   625,   356,   627,    -1,   625,
     251,   375,    -1,   625,   242,    -1,   625,   155,    -1,   625,
     357,    -1,   625,   358,    -1,   625,   355,    -1,   135,   354,
     449,     3,    -1,   361,    -1,   373,    -1,   382,    -1,   388,
      -1,   391,    -1,   405,    -1,   407,    -1,   411,    -1,   414,
      -1,   632,    -1,   422,    -1,   485,    -1,   487,    -1,   497,
      -1,   392,    -1,   393,    -1,   394,    -1,   395,    -1,   396,
      -1,   397,    -1,   445,    -1,   446,    -1,   447,    -1,   448,
      -1,   450,    -1,   451,    -1,   452,    -1,   455,    -1,   458,
      -1,   461,    -1,   462,    -1,   463,    -1,   464,    -1,   465,
      -1,   466,    -1,   467,    -1,   468,    -1,   469,    -1,   470,
      -1,   471,    -1,   474,    -1,   475,    -1,   476,    -1,   477,
      -1,   478,    -1,   479,    -1,   480,    -1,   481,    -1,   482,
      -1,   570,    -1,   571,    -1,   572,    -1,   573,    -1,   574,
      -1,   575,    -1,   576,    -1,   577,    -1,   629,    -1,   633,
     364,    -1,   634,   364,    -1,   431,   364,    -1,   537,   364,
      -1,   539,   364,    -1,   580,   364,    -1,   586,    -1,   615,
     364,    -1,   624,   364,    -1,   400,   416,   363,    -1,   633,
     417,   361,    -1,   633,   401,   361,    -1,   633,   404,   361,
      -1,   402,   416,   363,    -1,   634,   417,   361,    -1,   634,
     403,   361,    -1,    71,    -1,    72,    -1,    75,    -1,    76,
      -1,   134,    -1,     5,    -1,   224,    -1,   221,    -1,   225,
      -1,   223,    -1,   222,    -1,   226,    -1,   227,    -1,   228,
      -1,   247,    -1,   248,    -1,   229,    -1,   259,    -1,   260,
      -1,   261,    -1,   262,    -1,   352,    -1,   353,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   669,   669,   670,   673,   675,   682,   683,   684,   690,
     694,   703,   704,   705,   706,   707,   708,   714,   715,   722,
     723,   727,   734,   735,   739,   743,   750,   758,   759,   765,
     774,   775,   779,   784,   785,   789,   790,   794,   795,   799,
     800,   801,   802,   803,   804,   805,   806,   807,   813,   814,
     823,   824,   825,   826,   829,   830,   831,   832,   836,   843,
     846,   853,   856,   859,   862,   866,   867,   871,   872,   873,
     881,   886,   887,   891,   898,   904,   909,   913,   927,   941,
     942,   946,   947,   948,   959,   961,   963,   967,   968,   969,
     970,   977,   978,   982,   990,   994,   996,  1002,  1003,  1010,
    1011,  1015,  1021,  1025,  1035,  1037,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1056,  1057,
    1058,  1059,  1063,  1064,  1065,  1066,  1067,  1071,  1080,  1088,
    1089,  1097,  1105,  1106,  1107,  1111,  1112,  1116,  1121,  1122,
    1125,  1133,  1140,  1147,  1148,  1149,  1153,  1161,  1167,  1168,
    1169,  1173,  1174,  1178,  1179,  1180,  1181,  1182,  1183,  1189,
    1190,  1191,  1195,  1196,  1200,  1201,  1207,  1208,  1211,  1213,
    1217,  1218,  1222,  1240,  1241,  1242,  1243,  1244,  1245,  1253,
    1256,  1259,  1262,  1266,  1267,  1270,  1273,  1277,  1281,  1287,
    1293,  1300,  1305,  1310,  1315,  1319,  1323,  1327,  1337,  1345,
    1349,  1356,  1357,  1362,  1366,  1373,  1380,  1384,  1392,  1393,
    1394,  1399,  1403,  1406,  1407,  1408,  1409,  1410,  1411,  1412,
    1417,  1422,  1430,  1437,  1444,  1452,  1454,  1456,  1458,  1460,
    1462,  1464,  1467,  1473,  1474,  1475,  1479,  1480,  1486,  1488,
    1490,  1492,  1494,  1496,  1500,  1504,  1507,  1511,  1512,  1513,
    1517,  1518,  1519,  1527,  1527,  1537,  1541,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1574,
    1585,  1586,  1593,  1594,  1601,  1610,  1614,  1618,  1642,  1643,
    1647,  1660,  1660,  1676,  1677,  1680,  1681,  1685,  1688,  1697,
    1710,  1711,  1712,  1713,  1717,  1718,  1719,  1720,  1721,  1725,
    1728,  1729,  1730,  1734,  1737,  1746,  1749,  1750,  1751,  1752,
    1756,  1757,  1758,  1762,  1763,  1764,  1765,  1769,  1770,  1771,
    1772,  1776,  1777,  1781,  1782,  1786,  1793,  1794,  1795,  1796,
    1803,  1804,  1807,  1808,  1815,  1827,  1828,  1832,  1833,  1837,
    1838,  1839,  1840,  1841,  1845,  1846,  1847,  1851,  1852,  1853,
    1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1865,  1866,
    1876,  1880,  1903,  1939,  1941,  1942,  1943,  1944,  1945,  1946,
    1947,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1968,  1969,  1970,
    1972,  1974,  1976,  1978,  1979,  1980,  1981,  1982,  1992,  1993,
    1994,  1995,  1996,  1997,  1998,  2000,  2001,  2006,  2029,  2030,
    2031,  2032,  2033,  2034,  2038,  2041,  2042,  2043,  2051,  2058,
    2067,  2068,  2072,  2078,  2088,  2097,  2103,  2108,  2115,  2120,
    2126,  2127,  2128,  2136,  2137,  2138,  2139,  2140,  2146,  2167,
    2168,  2169,  2170,  2171,  2181,  2182,  2183,  2184,  2185,  2186,
    2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
    2207,  2208,  2209,  2210,  2211,  2212,  2213,  2218,  2219,  2220,
    2221,  2222,  2233,  2243,  2244,  2248,  2249,  2250,  2251,  2252,
    2253,  2256,  2271,  2274,  2276,  2280,  2281,  2282,  2283,  2284,
    2285,  2286,  2287,  2288,  2289,  2289,  2290,  2290,  2291,  2292,
    2293,  2297,  2298,  2302,  2310,  2312,  2316,  2317,  2318,  2322,
    2323,  2326,  2328,  2331,  2332,  2333,  2334,  2335,  2336,  2337,
    2338,  2339,  2340,  2341,  2344,  2366,  2367,  2368,  2369,  2370,
    2371,  2372,  2373,  2374,  2375,  2376,  2377,  2378,  2379,  2380,
    2381,  2382,  2383,  2384,  2385,  2386,  2387,  2388,  2389,  2390,
    2391,  2392,  2393,  2394,  2395,  2398,  2400,  2403,  2405,  2414,
    2416,  2417,  2420,  2422,  2426,  2427,  2429,  2438,  2449,  2469,
    2471,  2474,  2476,  2479,  2481,  2485,  2489,  2490,  2495,  2498,
    2501,  2506,  2509,  2514,  2517,  2521,  2525,  2528,  2529,  2530,
    2531,  2532,  2533,  2534,  2535,  2541,  2548,  2549,  2550,  2555,
    2556,  2562,  2572,  2573,  2574,  2575,  2575,  2576,  2576,  2579,
    2581,  2585,  2589,  2605,  2606,  2607,  2608,  2609,  2610,  2611,
    2612,  2613,  2614,  2615,  2616,  2616,  2617,  2617,  2618,  2619,
    2623,  2641,  2643,  2646,  2648,  2652,  2655,  2668,  2669,  2670,
    2671,  2672,  2676,  2681,  2683,  2686,  2688,  2692,  2696,  2706,
    2711,  2712,  2713,  2717,  2729,  2731,  2735,  2736,  2740,  2753,
    2758,  2759,  2760,  2764,  2776,  2778,  2782,  2783,  2788,  2789,
    2795,  2802,  2803,  2804,  2805,  2806,  2807,  2808,  2809,  2810,
    2811,  2812,  2813,  2814,  2818,  2819,  2820,  2825,  2826,  2827,
    2828,  2829,  2832,  2833,  2834,  2837,  2839,  2842,  2844,  2848,
    2857,  2864,  2871,  2872,  2873,  2874,  2875,  2878,  2887,  2895,
    2902,  2903,  2907,  2912,  2918,  2921,  2926,  2927,  2928,  2929,
    2930,  2933,  2940,  2940,  2940,  2940,  2940,  2940,  2940,  2940,
    2940,  2940,  2940,  2940,  2940,  2940,  2941,  2941,  2941,  2941,
    2941,  2941,  2941,  2941,  2941,  2941,  2941,  2941,  2941,  2941,
    2941,  2941,  2941,  2941,  2941,  2941,  2941,  2941,  2941,  2941,
    2941,  2941,  2941,  2941,  2941,  2941,  2941,  2941,  2941,  2941,
    2941,  2941,  2941,  2941,  2941,  2941,  2941,  2941,  2941,  2941,
    2942,  2942,  2942,  2942,  2942,  2942,  2942,  2942,  2942,  2943,
    2943,  2943,  2943,  2944,  2944,  2944,  2945,  2945,  2945,  2945,
    2945,  2946,  2946,  2947,  2948,  2949,  2950,  2951,  2952,  2953,
    2954,  2955,  2956,  2957,  2957,  2957,  2957,  2957,  2957
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE",
  "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR",
  "SOFT", "TIMEFORMAT", "ISO", "SHORT", "LONG", "BASE", "NAME", "CONFIRM",
  "UNDO", "CHECK", "TIMEOUT", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "KRT_SOURCE", "KRT_METRIC",
  "ASYNC", "TABLE", "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL",
  "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT",
  "EXPORT", "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT",
  "ACTION", "WARN", "BLOCK", "RESTART", "DISABLE", "KEEP", "FILTERED",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "GENERATE", "ROA", "MAX", "FLUSH", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION",
  "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT",
  "MEMORY", "IGP_METRIC", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET",
  "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX",
  "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST",
  "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "LEN", "DEFINED", "CONTAINS", "RESET", "PREPEND",
  "FIRST", "LAST", "MATCH", "ROA_CHECK", "EMPTY", "WHERE", "EVAL", "LOCAL",
  "NEIGHBOR", "AS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "MULTIHOP",
  "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH", "METRIC",
  "START", "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY",
  "DEAD", "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "SIMPLE",
  "AUTHENTICATION", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL",
  "NETWORKS", "HIDDEN", "VIRTUAL", "LINK", "RX", "BUFFER", "LARGE",
  "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP", "WEIGHT",
  "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID", "INSTANCE", "REAL",
  "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT",
  "RADV", "MIN", "RA", "INTERVAL", "MANAGED", "OTHER", "CONFIG", "MTU",
  "REACHABLE", "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT",
  "LIFETIME", "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS",
  "DOMAIN", "RIP", "INFINITY", "PERIOD", "GARBAGE", "MULTICAST", "QUIET",
  "NOLISTEN", "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS",
  "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE",
  "UNREACHABLE", "'('", "')'", "';'", "':'", "'{'", "'}'", "','", "'?'",
  "'['", "']'", "$accept", "config", "conf_entries", "expr", "definition",
  "bool", "ipa", "ipa_scope", "prefix", "prefix_or_ipa", "pxlen",
  "datetime", "text_or_none", "log_config", "syslog_name", "log_file",
  "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_item", "kif_proto_start",
  "kif_item", "nl_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_init", "iface_patt",
  "dev_proto_start", "dev_proto", "dev_iface_init", "dev_iface_patt",
  "debug_mask", "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_or_preexport", "cmd_SHOW_ROA",
  "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE",
  "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT",
  "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2",
  "filter_def", "$@1", "filter_eval", "type", "one_decl", "decls",
  "declsn", "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "fipa", "set_atom", "switch_atom", "pair_expr", "pair_atom", "pair_item",
  "ec_expr", "ec_kind", "ec_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "ipa_list", "ipa_item", "ipa_el", "ipa_ne",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@5", "$@6", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@7", "$@8", "radv_iface_finish",
  "radv_iface_opts", "radv_iface_opt_list", "radv_iface",
  "radv_prefix_start", "radv_prefix_item", "radv_prefix_finish",
  "radv_prefix_opts", "radv_prefix_opt_list", "radv_prefix",
  "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "rip_cfg_start", "rip_cfg",
  "rip_auth", "rip_mode", "rip_iface_item", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,    40,
      41,    59,    58,   123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   369,   370,   370,   371,   371,   372,   372,   372,   373,
     373,   374,   374,   374,   374,   374,   374,   375,   375,   376,
     376,   377,   378,   378,   379,   379,   380,   381,   381,   382,
     383,   383,   384,   384,   384,   385,   385,   386,   386,   387,
     387,   387,   387,   387,   387,   387,   387,   387,   388,   388,
     389,   389,   389,   389,   390,   390,   390,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   398,   399,   399,   399,
     400,   401,   401,   401,   401,   402,   403,   403,   404,   405,
     405,   406,   406,   406,   407,   408,   408,   409,   409,   409,
     409,   410,   410,   411,   412,   413,   413,   414,   414,   415,
     415,   416,   416,   416,   417,   417,   417,   417,   417,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   418,   418,
     418,   418,   419,   419,   419,   419,   419,   420,   421,   422,
     422,   423,   424,   424,   424,   425,   425,   426,   427,   427,
     428,   429,   430,   431,   431,   431,   432,   433,   434,   434,
     434,   435,   435,   436,   436,   436,   436,   436,   436,   437,
     437,   437,   438,   438,   439,   439,   440,   440,   441,   441,
     442,   442,   443,   444,   444,   444,   444,   444,   444,   445,
     446,   447,   448,   449,   449,   450,   451,   452,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453,   453,
     453,   454,   454,   455,   456,   456,   456,   456,   457,   457,
     457,   458,   459,   459,   459,   459,   459,   459,   459,   459,
     460,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   472,   472,   473,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   483,   483,
     484,   484,   484,   486,   485,   487,   488,   488,   488,   488,
     488,   488,   488,   488,   488,   488,   488,   488,   488,   489,
     490,   490,   491,   491,   492,   493,   493,   494,   495,   495,
     496,   498,   497,   499,   499,   500,   500,   501,   501,   502,
     503,   503,   503,   503,   504,   504,   504,   504,   504,   505,
     506,   506,   506,   507,   507,   508,   509,   509,   509,   509,
     510,   510,   510,   511,   511,   511,   511,   512,   512,   512,
     512,   513,   513,   514,   514,   515,   516,   516,   516,   516,
     517,   517,   518,   518,   518,   519,   519,   520,   520,   521,
     521,   521,   521,   521,   522,   522,   522,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   524,   524,
     525,   526,   527,   528,   528,   528,   528,   528,   528,   528,
     528,   529,   529,   529,   529,   529,   529,   529,   529,   529,
     529,   529,   529,   529,   529,   529,   529,   529,   529,   529,
     529,   529,   529,   529,   529,   529,   529,   529,   529,   529,
     529,   529,   529,   529,   529,   529,   529,   529,   530,   530,
     530,   530,   530,   530,   531,   532,   532,   532,   533,   533,
     534,   534,   535,   535,   535,   535,   535,   535,   535,   535,
     535,   535,   535,   535,   535,   535,   535,   535,   536,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   538,   539,   539,   540,   540,   540,   540,   540,
     540,   541,   542,   543,   543,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   545,   544,   546,   544,   544,   544,
     544,   547,   547,   548,   549,   549,   550,   550,   550,   551,
     551,   552,   552,   553,   553,   553,   553,   553,   553,   553,
     553,   553,   553,   553,   554,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   556,   556,   557,   558,   559,
     559,   559,   560,   560,   561,   561,   562,   563,   564,   565,
     565,   566,   566,   567,   567,   568,   569,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   579,   580,   580,   580,   580,
     580,   581,   582,   582,   582,   583,   582,   584,   582,   585,
     585,   586,   587,   588,   588,   588,   588,   588,   588,   588,
     588,   588,   588,   588,   589,   588,   590,   588,   588,   588,
     591,   592,   592,   593,   593,   594,   595,   596,   596,   596,
     596,   596,   597,   598,   598,   599,   599,   600,   601,   602,
     603,   603,   603,   604,   605,   605,   606,   606,   607,   608,
     609,   609,   609,   610,   611,   611,   612,   612,   613,   613,
     614,   615,   615,   615,   615,   615,   615,   615,   615,   615,
     615,   615,   615,   615,   616,   616,   616,   617,   617,   617,
     617,   617,   618,   618,   618,   619,   619,   620,   620,   621,
     622,   623,   624,   624,   624,   624,   624,   625,   626,   626,
     627,   627,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   629,   630,   630,   630,   630,   630,   630,   630,   630,
     630,   630,   630,   630,   630,   630,   631,   631,   631,   631,
     631,   631,   631,   631,   631,   631,   631,   631,   631,   631,
     631,   631,   631,   631,   631,   631,   631,   631,   631,   631,
     631,   631,   631,   631,   631,   631,   631,   631,   631,   631,
     631,   631,   631,   631,   631,   631,   631,   631,   631,   631,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   633,
     633,   633,   633,   634,   634,   634,   635,   635,   635,   635,
     635,   635,   635,   635,   635,   635,   635,   635,   635,   635,
     635,   635,   635,   635,   635,   635,   635,   635,   635
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     0,
       2,     2,     1,     1,     2,     2,     1,     1,     0,     4,
       2,     0,     1,     2,     1,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     3,
       1,     1,     1,     1,     2,     4,     3,     3,     3,     4,
       5,     3,     3,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     2,     3,     2,     3,     3,     3,     4,
       5,     1,     1,     1,     4,     0,     2,     2,     2,     1,
       1,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     3,     0,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     4,     2,     3,     2,     2,     1,
       1,     1,     0,     2,     2,     2,     2,     2,     1,     3,
       3,     0,     1,     1,     2,     0,     1,     3,     1,     3,
       0,     2,     2,     3,     3,     3,     0,     3,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     4,     1,     0,     3,
       4,     1,     2,     0,     5,     5,     5,     5,     4,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     2,     3,     3,     2,
       2,     1,     1,     4,     0,     3,     3,     3,     0,     1,
       1,     4,     0,     2,     2,     2,     2,     2,     2,     2,
       0,     2,     9,     9,     4,     3,     3,     3,     3,     3,
       3,     3,     4,     1,     1,     1,     0,     1,     3,     3,
       3,     3,     4,     4,     4,     4,     2,     1,     1,     1,
       1,     0,     1,     0,     4,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       0,     3,     1,     3,     1,     1,     1,     2,     3,     2,
       4,     0,     5,     0,     1,     1,     2,     1,     3,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     3,     1,     5,    11,     1,     1,     1,     2,     1,
       7,     9,     7,     1,     1,     1,     3,     1,     1,     1,
       3,     1,     3,     1,     3,     3,     1,     2,     2,     6,
       1,     3,     0,     4,     3,     1,     3,     3,     3,     2,
       2,     2,     2,     0,     2,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     1,     1,     5,     7,
       0,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     4,     1,     1,     1,
       1,     2,     2,     3,     3,     6,     3,     3,     3,     3,
       5,     6,     6,     6,     6,     4,     8,     4,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     1,     3,
       0,     1,     4,     6,     4,     3,     5,     5,     4,     6,
       3,     2,     5,     5,     8,     8,     8,     8,     2,     3,
       3,     5,     6,     7,     6,     4,     4,     5,     6,     6,
       5,     3,     4,     5,     5,     5,     5,     4,     4,     5,
       5,     5,     5,     5,     5,     5,     5,     6,     6,     8,
       6,     6,     5,     4,     5,     4,     5,     4,     5,     4,
       5,     5,     2,     3,     3,     1,     2,     2,     4,     2,
       1,     2,     4,     0,     3,     2,     1,     2,     3,     3,
       3,     3,     2,     3,     0,     5,     0,     5,     2,     2,
       1,     4,     1,     1,     0,     3,     2,     2,     2,     5,
       2,     0,     3,     0,     2,     2,     3,     2,     2,     3,
       2,     2,     2,     1,     3,     2,     2,     2,     2,     2,
       2,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     3,     2,     3,     2,     3,     3,     4,     2,     2,
       2,     3,     3,     3,     1,     0,     2,     3,     1,     0,
       1,     2,     0,     2,     1,     1,     2,     3,     0,     0,
       2,     0,     3,     0,     3,     4,     1,     0,     4,     6,
       6,     6,     7,     6,     7,     5,     0,     2,     3,     2,
       3,     3,     2,     3,     2,     2,     3,     3,     5,     4,
       4,     2,     1,     2,     2,     0,     3,     0,     3,     0,
       3,     5,     0,     4,     4,     3,     2,     3,     3,     3,
       3,     4,     3,     2,     0,     3,     0,     3,     3,     3,
       0,     0,     3,     0,     3,     4,     1,     2,     2,     2,
       3,     3,     0,     0,     3,     0,     3,     3,     1,     0,
       0,     2,     2,     0,     0,     3,     1,     5,     1,     0,
       0,     2,     2,     0,     0,     3,     1,     5,     1,     2,
       2,     3,     3,     4,     4,     4,     5,     5,     4,     3,
       4,     4,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     2,     2,     0,     3,     0,     3,     0,
       3,     2,     3,     3,     5,     5,     3,     2,     3,     3,
       1,     2,     4,     3,     3,     3,     2,     2,     2,     2,
       2,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     1,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    65,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   765,   766,
     767,   768,   769,   770,   771,   772,   773,   774,   775,   776,
     777,   778,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,     3,     1,     2,     0,     0,     0,     0,
       0,     0,    99,   100,     0,     0,     0,     0,     0,   360,
     732,   733,   734,   735,   736,   101,   101,   737,   738,   739,
      97,   740,     0,   742,   101,   104,   743,   744,   745,   101,
     104,   101,   104,   101,   104,   101,   796,   101,   104,   101,
     104,     5,   741,   104,   104,   247,   249,   248,     0,    66,
      65,     0,     0,    65,    67,    64,     0,     0,   220,     0,
       0,     0,     0,   246,   251,     0,   204,     0,     0,   188,
     212,   184,   184,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   234,   233,   236,     0,     0,    32,    31,
      34,     0,     0,     0,    53,    52,    51,    50,     0,     0,
      91,     0,   253,     0,    85,     0,     0,   281,   343,   347,
     356,   353,   289,   362,   350,     0,     0,   346,   360,   390,
       0,     0,     0,   348,   349,     0,     0,     0,   360,     0,
     351,   352,   357,   388,   389,     0,   387,   255,   102,     0,
       0,    95,    70,    75,   142,   438,   482,   605,   611,   680,
     711,     0,     0,     0,     0,     0,    16,   146,     0,     0,
       0,     0,     0,   792,     0,     0,     0,     0,     0,     0,
      16,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,     0,
       0,     0,     0,     0,     0,     0,     0,    16,   793,     0,
       0,     0,    16,     0,    16,   794,   485,     0,     0,   490,
       0,     0,     0,   795,     0,     0,     0,     0,   709,     0,
       0,     0,     0,     0,     0,     0,     0,   797,     0,     0,
     167,   171,     0,     0,     0,     0,   798,     0,     0,     0,
       0,    16,     0,    16,     0,   790,     0,     0,     0,     0,
      28,   791,     0,     0,   149,   148,     0,     0,    67,    61,
      62,     0,    68,     0,   240,   238,     0,     0,     0,     0,
     241,   160,   159,     0,     0,   250,   252,   251,     0,   185,
       0,   208,   180,   179,     0,     0,   183,   184,   184,   596,
     184,   184,     0,     0,    17,    18,     0,     0,     0,   230,
     231,   227,   225,   226,   228,   229,   237,     0,   239,     0,
       0,    33,    35,     0,     0,   129,     6,     8,   360,   130,
      54,     0,    58,    92,    93,    81,    82,    83,   140,     0,
     270,    94,     0,    49,     0,     0,   343,   362,   343,   360,
     343,   343,     0,   335,     0,   360,     0,     0,     0,   346,
     346,     0,   385,   360,   360,   360,   360,   360,     0,   306,
     307,     0,   309,     0,     0,   293,   291,   360,   290,   292,
     315,   313,   314,   321,     0,   326,   330,     0,   811,   806,
     807,   808,   809,   363,   810,   364,   365,   366,   367,   368,
     369,   370,   813,   816,   815,   812,   814,   817,   818,   819,
     822,   820,   821,   823,   824,   825,   826,   827,   828,   391,
     392,   360,   360,   360,   360,   360,   360,   360,   360,   360,
     360,   360,   360,   360,     0,     0,   799,   803,     0,   143,
     107,   128,   115,     0,   105,    12,    14,    13,    15,    11,
     106,   131,   120,   270,   121,     0,     0,   360,   109,   119,
       0,   110,     0,   117,   108,   144,   145,   439,     0,     0,
       0,     0,     0,     0,     0,    16,     0,     0,     0,    19,
       0,     0,     0,   451,     0,     0,     0,     0,     0,    16,
       0,     0,     0,     0,    16,     0,    16,     0,    16,     0,
      16,     0,     0,    16,    16,    16,     0,   440,   483,   491,
     486,   489,   487,   484,   493,   606,     0,     0,     0,   607,
     619,   681,     0,   131,     0,   172,     0,   168,   696,   694,
     695,     0,     0,     0,     0,     0,     0,     0,   682,   689,
     173,   712,    16,   717,     0,   713,   727,     0,   726,     0,
     730,     0,   728,   729,   716,     0,    71,     0,    73,    16,
     801,   802,   800,     0,    27,     0,   805,   804,   154,   153,
     155,   157,   158,   156,     0,   151,   244,     0,    63,    69,
      59,   221,   224,   242,   243,   164,   165,     0,   162,   245,
       0,   181,   186,   203,     0,   210,   209,     0,     0,   187,
     194,     0,     0,   202,   270,   196,   195,   199,   200,     0,
     201,   189,     0,   193,   211,   219,   213,   216,   217,   215,
     218,   214,   587,   587,     0,   184,   587,   184,   587,   588,
     731,     0,     0,    21,     0,     0,   232,     0,     0,    30,
      39,    40,    41,    42,    43,    44,    45,    46,    47,     0,
      37,    29,     0,     0,    56,    57,   131,     0,    79,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,     0,     0,     0,   254,   274,    89,    90,     0,     0,
      84,    86,    48,     0,   270,   339,   340,     0,   341,   342,
     337,   325,   418,   421,     0,   398,     0,   399,   344,   345,
     338,     0,     0,     0,     0,     0,     0,   308,   360,   371,
     360,   302,   300,     0,     0,   299,     0,     0,   354,   327,
     328,     0,     0,   355,   383,   381,   379,   376,   377,   378,
     380,   382,   384,   372,   373,   374,   375,   393,     0,   394,
     396,   397,   103,     0,    98,   116,   135,   138,   147,   275,
     276,   118,   122,   112,    16,   277,   113,   111,     0,     0,
      16,   475,   477,     0,    16,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   452,     0,     0,     0,     0,     0,
       0,   445,     0,   446,     0,   473,     0,     0,     0,     0,
       0,     0,     0,   457,   458,     0,     0,     0,   479,     0,
       0,     0,   609,   610,   104,     0,   707,   693,   684,     0,
       0,   688,   683,   685,     0,   691,   692,   690,     0,     0,
       0,     0,     0,     0,   723,    19,   725,     0,   720,   724,
      78,    72,    74,    76,    23,    22,    77,   150,     0,    60,
     161,     0,   182,   207,   206,   205,   191,   198,   192,   190,
     197,   586,     0,     0,   595,   604,     0,   602,     0,     0,
     599,   597,     0,   587,     0,   587,     0,    24,    25,     0,
       0,    10,     9,    36,     0,     7,    55,   141,    80,   269,
     268,   270,   360,    87,    88,   279,   272,     0,   282,   336,
     360,   407,     0,   360,   360,   360,   386,   360,   405,   360,
       0,     0,   360,   360,   360,   289,   316,   322,     0,     0,
     331,   360,     0,   136,     0,   131,     0,   127,   114,     0,
       0,     0,   476,     0,   472,   466,   441,     0,    20,     0,
     447,     0,   450,     0,   453,   465,   464,   459,     0,     0,
     474,   462,   454,   455,   456,   478,   480,   461,   460,   481,
     463,   488,   578,    16,     0,    16,   504,     0,     0,   506,
     496,    16,   492,     0,   510,   579,   608,   622,     0,   615,
     617,   621,   612,     0,   687,   705,   710,   166,   168,   686,
       0,     0,     0,     0,     0,   170,   714,   715,   722,    19,
       0,   721,   152,   163,   590,   589,   603,   598,   600,   601,
       0,   591,     0,   593,     0,     0,    38,   271,     0,   411,
       0,   412,   413,     0,   360,   409,   410,   408,   360,   360,
       0,   360,     0,     0,   360,   285,     0,   278,   419,   400,
       0,     0,     0,     0,     0,   360,   358,   301,   299,     0,
       0,   305,     0,     0,     0,   132,   133,   137,   139,   123,
     124,   125,   126,   468,     0,   470,   471,   442,     0,   449,
     448,   467,   444,   131,   509,   497,     0,     0,    16,     0,
     495,     0,     0,   513,   508,   512,     0,     0,   502,   494,
       0,   520,   131,   613,   646,   655,   614,     0,     0,   620,
     702,   169,   173,    26,     0,     0,     0,     0,   718,   719,
     592,   594,   220,   220,   360,   360,   360,   360,     0,     0,
       0,   280,   286,     0,     0,   431,   414,   416,     0,   273,
     404,   402,   403,   401,   360,     0,   303,   360,     0,   395,
       0,   134,     0,   443,   579,   499,   500,   498,   501,   565,
     534,   514,   565,   503,   580,   521,   643,   653,   652,   659,
     658,   666,   616,   668,   669,   676,   618,     0,     0,   708,
       0,   178,   173,   173,   173,   173,     0,     0,     0,     0,
       0,     0,   425,   360,   332,   360,   360,     0,   360,   430,
       0,   359,     0,     0,     0,   329,     0,   469,   583,     0,
       0,     0,   523,   641,   640,     0,   657,   664,   674,   703,
     697,   698,   699,   700,   701,   704,   706,   174,   175,   176,
     177,   222,   223,   424,   361,   428,     0,   360,   422,   287,
       0,     0,     0,     0,     0,     0,     0,     0,   417,   406,
     360,   312,   360,   310,     0,   581,   585,   505,   568,   566,
     569,    16,     0,    16,   511,     0,   507,     0,     0,     0,
       0,     0,     0,   519,   533,     0,     0,   645,     0,     0,
      16,    16,    16,   656,     0,   660,   670,     0,     0,   360,
     360,   294,   298,   296,   360,   432,   297,   319,   317,   318,
     323,     0,   427,   426,   360,   360,   360,   360,   433,     0,
       0,    96,     0,   570,     0,     0,   517,   518,   516,   515,
     527,   525,   524,     0,     0,   528,   530,   531,   532,   522,
       0,     0,     0,     0,     0,    16,     0,     0,     0,     0,
     634,   636,   644,     0,     0,     0,   647,   648,   649,   654,
       0,     0,   663,     0,     0,     0,   673,     0,   429,   288,
     423,   334,   299,     0,   360,     0,     0,     0,     0,     0,
     360,   311,     0,     0,     0,    16,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   584,
     564,     0,   571,   567,   526,   529,     0,   633,     0,     0,
       0,     0,   626,    16,     0,     0,     0,    16,     0,    16,
       0,   642,   650,   651,     0,   678,   662,   661,   667,   665,
     672,   671,   677,   675,   295,   360,   320,   333,   324,     0,
       0,     0,     0,     0,    16,   572,   539,   554,   535,   538,
     536,     0,   552,     0,   540,   542,   543,   544,   545,   546,
     547,   548,   549,   558,   559,   560,    16,   537,     0,     0,
      16,   582,     0,   632,   628,   625,     0,   627,   629,   630,
       0,   638,   635,   639,   637,   679,     0,   437,   435,   436,
     434,   304,   555,     0,   551,   541,   553,   561,   562,   563,
     556,   550,   624,   623,   631,     0,   557,   573,   574,   575,
       0,   576,   577
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   509,    81,   510,   366,   830,   895,   896,
     693,  1154,   625,    82,   381,   161,   384,   709,   710,    83,
     168,   169,    84,    19,    20,    21,    22,    23,    24,   124,
     333,    85,   316,    86,   322,   317,    87,   399,    88,   402,
     741,   394,    89,    90,   498,    91,    92,   209,   234,   518,
     977,   813,   502,    93,   806,  1107,   974,   807,   808,   716,
     717,    94,    95,   511,   235,   327,   634,   635,   344,   647,
     648,   299,   869,   300,   301,   881,    25,    26,    27,    28,
     362,    29,    30,    31,   354,   672,    32,   351,   658,    33,
     355,   337,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,   155,   377,    45,    46,    47,    48,    49,
      50,    51,    52,    53,   118,   348,    96,   400,    97,   731,
     732,   733,   947,   810,   811,   519,   744,   735,    98,   405,
    1080,  1081,  1278,   200,   440,  1337,   772,   773,   441,  1100,
     774,   442,   443,  1340,   444,  1341,   201,   446,   447,  1280,
     411,   202,   412,   421,   203,   204,   205,  1083,   206,   479,
    1098,  1084,  1177,  1178,   753,   754,  1085,    99,   100,   101,
     102,   277,   278,   279,   860,  1023,  1131,  1136,  1134,  1135,
    1250,  1305,  1024,  1252,  1315,  1025,  1431,  1249,  1299,  1300,
    1355,  1523,  1537,  1538,  1539,  1123,  1141,  1352,  1296,  1124,
     912,    54,    55,    56,    57,    58,    59,    60,    61,   684,
     103,   104,   105,  1033,  1147,  1148,   864,   106,  1142,  1383,
    1448,  1450,  1317,  1316,  1254,  1143,  1145,  1324,  1256,  1255,
    1208,  1146,  1211,  1257,  1393,  1458,  1325,  1212,  1215,  1258,
    1397,  1462,  1326,  1216,  1456,   107,   108,   591,  1265,  1220,
    1150,  1036,   583,   584,   109,   110,   308,   888,   889,   309,
      62,   111,    63,   112,   113,   114,   480
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1141
static const yytype_int16 yypact[] =
{
      76,  2418,    90,   394,   558,   654,   140,   558,   558,    44,
     737,   558,   149,   636,    55,    91,  1036,   335,   558, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141,   162,   439,   333,   434,
     322,   276, -1141, -1141,   352,   306,   272,    85,   376,  1420,
   -1141, -1141, -1141, -1141, -1141,   431,   431, -1141, -1141, -1141,
      93, -1141,   937, -1141,   431,   484, -1141, -1141, -1141,   431,
    2138,   431,  2176,   431,   560,   431, -1141,   431,  1943,   431,
    2322, -1141, -1141,  1971,  2376, -1141, -1141, -1141,    30, -1141,
     476,   507,   513,   476,   483, -1141,   545,   553,   493,   558,
     558,   557,   196, -1141,   633,    84, -1141,   593,   612, -1141,
   -1141,    50,   554,   589,   589,   621,   632,   637,   640,   644,
     653,   667, -1141, -1141, -1141,   660,   680,   666, -1141,   647,
   -1141,    58,    30,   177, -1141, -1141, -1141, -1141,   284,   339,
     608,   643, -1141,   722, -1141,   397,   196, -1141,    20, -1141,
   -1141, -1141,   739,   417, -1141,   574,    37,     6,  1420, -1141,
     421,   428,   432, -1141, -1141,   443,   449,   471,   796,    42,
   -1141, -1141, -1141, -1141, -1141,  1907, -1141,  2301,   709,   491,
     495, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141,   497,    30,   820,   768,   177,   120, -1141,   440,   540,
     777,   859,   196, -1141,   521,   523,   525,   412,   685,   870,
     120,   825,   165,   798,   132,   589,   856,   747,   893,    17,
     758,   757,   441,   754,   759,   635,   761,   750,   120,   755,
     756,   764,    79,    -9,   781,   748,   763,   120, -1141,   650,
     656,   426,   120,   177,   120, -1141, -1141,   652,   658, -1141,
     659,   943,   572, -1141,   664,   665,   668,   963, -1141,  1012,
     177,   671,   -21,   177,   177,   966,   -43, -1141,   677,   681,
   -1141,   673,   678,   752,   589,   971, -1141,   686,   494,   687,
     972,   120,   982,   120,   980, -1141,   696,   699,   701,   991,
    1044, -1141,   702,   712, -1141, -1141,   849,  1071,   483, -1141,
   -1141,  1076,   177,  1077, -1141, -1141,  1062,  1079,  1080,  1081,
   -1141, -1141, -1141,   160,  1085, -1141, -1141,   906,  1087, -1141,
    1090,   349, -1141, -1141,  1269,   842, -1141,   554,   554, -1141,
     344,   486,  1091,  1095, -1141, -1141,    26,   984,   985, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141,  1099, -1141,    92,
    1083, -1141, -1141,  1509,   743, -1141, -1141, -1141,  1420, -1141,
     177,   873, -1141, -1141, -1141, -1141, -1141, -1141, -1141,   746,
    1980, -1141,   153, -1141,   749,   760,    20, -1141,    20,  1420,
      20,    20,  1097, -1141,  1094,  1157,  1089,   916,  1100,     6,
       6,  1101,  1084,  1420,  1420,  1420,  1420,  1420,  1107, -1141,
   -1141,  1103, -1141,   767,   104, -1141, -1141,   766, -1141, -1141,
    1121, -1141, -1141, -1141,   102,    27, -1141,   166, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141,  1420,  1420,  1420,  1420,  1420,  1420,  1420,  1420,  1420,
    1420,  1420,  1420,  1420,   830,  1110, -1141, -1141,   -53, -1141,
   -1141, -1141, -1141,   426, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141,  2261, -1141,   177,  1032,  1420, -1141, -1141,
     177, -1141,   177, -1141, -1141, -1141, -1141, -1141,  1078,  1082,
    1105,   785,   791,   177,   903,   120,   589,   177,   951,  1124,
     177,  1093,   177, -1141,   797,  1098,   949,   177,   177,   120,
    1104,   801,  1086,   806,   120,   817,   120,   188,   120,   820,
     120,   824,   826,   120,   120,   120,   828, -1141, -1141, -1141,
   -1141, -1141,  1074, -1141, -1141, -1141,  1172,   831,   832, -1141,
   -1141, -1141,   177, -1141,   835, -1141,   836,  1106, -1141, -1141,
   -1141,   837,   838,   839,   177,   840,   843,   854, -1141, -1141,
     275, -1141,   120, -1141,   820, -1141, -1141,   697, -1141,   589,
   -1141,   994, -1141, -1141, -1141,   177, -1141,   177, -1141,   120,
   -1141, -1141, -1141,   177, -1141,   589, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141,   566, -1141, -1141,  1207, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141,   568, -1141, -1141,
    1213, -1141, -1141, -1141,  1198, -1141, -1141,  1204,   589, -1141,
   -1141,  1202,  1206, -1141,  2261, -1141, -1141, -1141, -1141,   589,
   -1141, -1141,  1208, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141,  1203,  1203,   786,   554,  1203,   554,  1203, -1141,
   -1141,   177,   589, -1141,  1211,  1214, -1141,   871,   875, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,   570,
   -1141, -1141,   809,  1220, -1141, -1141, -1141,   881, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141,    63,   884,   868, -1141, -1141, -1141, -1141,   589,   177,
   -1141, -1141, -1141,  1604,  1980, -1141, -1141,   955, -1141, -1141,
   -1141, -1141,   176, -1141,   890, -1141,  1219, -1141, -1141, -1141,
   -1141,   235,   260,   290,  1576,   475,   170, -1141,  1420, -1141,
    1420, -1141,  1244,   887,   891,   809,    77,   129, -1141, -1141,
   -1141,  1242,  1240, -1141,  2559,  2559,  2559,  2570,  2570,  2559,
    2559,  2559,  2559,   775,   775,  1084,  1084, -1141,   900, -1141,
   -1141, -1141, -1141,   589, -1141, -1141,  1233, -1141,   896, -1141,
   -1141, -1141,  1169, -1141,   120,  2301, -1141, -1141,   177,   177,
     120, -1141, -1141,   908,   120,   909,   912,   913,   177,  1258,
    1108,   917,   177,   918, -1141,   177,   919,   920,   921,   922,
     177, -1141,   426, -1141,   925, -1141,   928,   931,   932,   934,
     935,   945,   946, -1141, -1141,   947,   950,   952, -1141,   177,
     369,   962, -1141, -1141,  2276,   965,  -245, -1141, -1141,   948,
     967, -1141, -1141, -1141,   968, -1141, -1141, -1141,   177,   451,
     487,   960,   969,   973, -1141,  1124, -1141,   589,  1026,   994,
   -1141, -1141, -1141, -1141,    26, -1141, -1141, -1141,   849, -1141,
   -1141,   160, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141,  1330,  1332, -1141, -1141,   426, -1141,   426,  1321,
   -1141, -1141,   426,  1203,  1334,  1203,  1338, -1141, -1141,  1140,
    1145, -1141, -1141, -1141,  1509, -1141, -1141,   896, -1141, -1141,
   -1141,  1980,  1149, -1141, -1141, -1141,   989,   992, -1141, -1141,
    1420, -1141,  1324,  1420,  1420,  1420, -1141,  1420, -1141,  1420,
     594,  1609,  1420,  1344,  1420, -1141, -1141, -1141,   993,   739,
   -1141,  1420,  1249, -1141,   734, -1141,   805, -1141, -1141,  1005,
    1002,  1008, -1141,  1013, -1141, -1141, -1141,  1015, -1141,   177,
   -1141,  1023, -1141,  1024, -1141, -1141, -1141, -1141,  1027,  1034,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141,   120,   209,    66, -1141,  1116,   589, -1141,
   -1141,   204, -1141,  1035, -1141,  1102, -1141, -1141,   589, -1141,
   -1141, -1141, -1141,  1047, -1141, -1141, -1141, -1141,  1106, -1141,
    1050,  1377,  1377,  1377,  1377, -1141, -1141, -1141, -1141,  1124,
     177,  1026, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
    1409, -1141,  1410, -1141,  1400,  1407, -1141, -1141,     9, -1141,
    1402, -1141, -1141,  1064,  1420, -1141, -1141, -1141,  1420,  1420,
    1070,    10,  1907,  1065,  1374, -1141,  1980, -1141, -1141, -1141,
    1634,  1659,  1690,  1720,   670,  1420, -1141, -1141,  2301,  1088,
    1092,  2301,  1426,  1766,  1427,   589, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141,   177, -1141, -1141, -1141,  1109, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141,   177,   177,   120,   177,
   -1141,  1096,   426, -1141, -1141,  1111,  1117,   177, -1141, -1141,
     177,  1118, -1141, -1141, -1141,  1120, -1141,    22,     4, -1141,
      -8, -1141,   275, -1141,  1125,  1126,  1136,  1137, -1141, -1141,
   -1141, -1141,   493,   493,  1420,  1157,  1420, -1141,   738,  2095,
     698, -1141, -1141,  1421,   157, -1141,  2301,  1135,  1141, -1141,
   -1141, -1141, -1141, -1141,  1420,  1791,  1437,  1401,  1139, -1141,
    1243, -1141,  1143, -1141,   -10, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141,   321, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141,   177,   455, -1141,
    1144, -1141,   275,   275,   275,   275,  1447,  1449,   886,  1146,
    1043,  1935, -1141,  1845, -1141,  1420,  1420,   379,  1374, -1141,
    1821, -1141,  1113,  1148,    13, -1141,  1438, -1141,  1147,    19,
     -69,    32,   587, -1141, -1141,   675, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141,  1151,  1149,  1282, -1141,
      28,  1112,  1467,  1150,  1153,  1161,  1162,  1173, -1141, -1141,
    1420, -1141,  1420, -1141,  1174, -1141, -1141, -1141, -1141, -1141,
     240,   120,   177,   120, -1141,  1176, -1141,   177,   177,   177,
    1239,   233,    -5, -1141, -1141,  1177,  2158, -1141,  1127,  1129,
     120,   120,   120, -1141,  1178,    97,   298,  1182,  1158,  1845,
      60, -1141, -1141, -1141,   766, -1141, -1141,  1455, -1141, -1141,
   -1141,   232, -1141, -1141,  1420,  1420,  1420,  1420, -1141,  1179,
    1163, -1141,  2255, -1141,   177,  1184, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141,   177,   177, -1141, -1141, -1141, -1141, -1141,
    1228,   589,  1132,  1142,  -146,   120,  1225,  1397,  1236,  1255,
    1268,  1271, -1141,  1210,   177,   177, -1141, -1141, -1141, -1141,
     203,   589, -1141,  1212,   203,  1539, -1141,  1216, -1141, -1141,
   -1141, -1141,  1846,   106,    60,   159,  1871,  1896,  1921,  1948,
    1420, -1141,  1273,  1205,   177,   120,   177,   177,   177,  1252,
     177,   342,  1251,    -4,  1289,   177,  1274,  1277,  1295, -1141,
   -1141,  1218, -1141, -1141, -1141, -1141,  1253, -1141,   177,   177,
     177,  1261, -1141,   120,   177,   177,  1482,   120,    22,   120,
       4, -1141, -1141, -1141,   177, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141,  1420, -1141, -1141, -1141,  1221,
    1222,  1230,  1231,  1229,   120, -1141, -1141, -1141, -1141, -1141,
   -1141,   177, -1141,   177, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141,   120, -1141,   163,   177,
     120, -1141,   177, -1141, -1141, -1141,   177, -1141, -1141, -1141,
     177, -1141, -1141, -1141, -1141, -1141,  1846, -1141, -1141, -1141,
   -1141, -1141, -1141,    34, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141,   -36, -1141, -1141, -1141, -1141,
    1235, -1141, -1141
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1141, -1141, -1141,  -100, -1141,  -225,  -243,  -796,  -137,  -651,
   -1141,  -200, -1141, -1141, -1141, -1141, -1141, -1141,   672, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,   419,
    1279, -1141, -1141, -1141, -1141, -1141, -1141,  -268, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141,  1134,   -91,  1352,
   -1141,   217,  -462, -1141, -1141, -1141, -1141,   638,  -578, -1141,
   -1141, -1141, -1141, -1141, -1141,   -54, -1141,   713,   130, -1141,
     714, -1115,   576,  -575, -1141,  -612, -1141, -1141, -1141, -1141,
    -132, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141,  -216, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141,   539,  1263, -1141, -1141, -1141, -1141,
    -670,   682,   536,  1224,   961,  1272, -1141,   883, -1141, -1141,
    -949, -1141,   299,  -191,   853,   227,  -948,   676, -1140, -1083,
    1442, -1109,   872,   242, -1141, -1141,  -195,   866, -1141, -1141,
   -1141, -1141,   418,   529, -1141, -1141,  -912, -1141,   173,   569,
     -79, -1141, -1141,   414,   700,   488, -1009, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141,   452, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141,   461, -1141, -1141, -1141,
    -432, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141, -1141,
   -1141,   293,   274, -1141, -1141, -1141, -1141,   224,   278, -1141,
   -1141, -1141, -1141,   225,   280, -1141, -1141, -1141, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141, -1141,   787, -1141, -1141,
   -1141, -1141, -1141, -1141, -1141, -1141,  -965
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -421
static const yytype_int16 yytable[] =
{
     207,   538,   539,   569,   445,   866,   367,   368,   439,   269,
     363,   276,   870,   284,  1097,   532,  -284,   298,   909,   307,
    1292,   419,   318,   323,  1213,  -284,  -284,  -284,  -284,  1068,
    1082,  1164,   386,   555,  1330,   406,   387,   364,   365,   407,
     364,   365,   566,  1331,  1332,  1333,   965,   570,   408,   572,
     364,   365,  1535,   779,   780,   691,  1069,   386,   435,   436,
     182,   387,   803,   389,   417,   324,  -283,   588,  1301,   356,
     325,  1440,  1172,   946,   561,  -283,  -283,  -283,  -283,  1068,
       1,   386,   939,  1366,  1493,   387,   616,   349,   618,  1048,
      64,  1070,   386,   435,   436,   965,   387,   851,   382,   438,
     505,   506,   507,   508,  1244,   175,  1069,   386,   385,   422,
     697,   387,   481,   482,   483,   484,   485,  1174,  1035,   434,
     975,  1331,  1332,  1333,   965,   504,   486,   487,   488,   489,
     490,   491,   492,   493,   357,   386,   494,  1314,   937,   387,
    1338,  1070,   883,   125,   386,   435,   436,   965,   387,   544,
     364,   365,   133,   559,   505,   506,   507,   508,   595,   128,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,   603,   500,  1082,
     143,  1339,  1441,   571,  1331,  1332,  1333,   965,   386,  1236,
    1078,   157,   387,  1079,   481,   482,   483,   484,   485,  1237,
     586,   176,   386,   592,   593,   358,   387,  1302,   486,   487,
     488,   489,   490,   491,   492,   493,   144,  1217,   494,  1350,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,   671,   386,   386,
    1303,   350,   387,   387,  1279,   682,   683,   940,   686,   688,
    1078,   341,   639,  1079,   418,   805,   342,  1430,   505,   506,
     507,   508,   562,   481,   482,   483,   484,   485,   386,   645,
    1540,   913,   387,  1158,   924,  1231,   926,   486,   487,   488,
     489,   490,   491,   492,   493,  1338,  1276,   494,   481,   482,
     483,   484,   485,   736,   737,   738,   739,  1367,  1494,   698,
    1368,  1495,   486,   487,   488,   489,   490,   491,   492,   493,
     713,   646,   494,   826,   560,  1304,  1339,  1140,   481,   482,
     483,   484,   485,   534,   390,  1218,   404,   596,   597,   712,
     825,   804,   486,   487,   488,   489,   490,   491,   492,   493,
    1279,  1082,   494,  1106,   839,  1541,   589,   590,  1328,   844,
     747,   846,  1129,   850,   537,   852,   752,   391,   855,   856,
     857,   170,  1349,  1364,   761,   762,   763,   764,   765,   359,
     152,   413,   653,   878,   171,   975,  1219,   386,   775,   360,
     361,   387,   524,   356,   885,  1082,   886,  1214,  1165,  -284,
     153,   172,   420,  1293,  -284,   154,   388,   882,   543,   409,
     173,  1401,   894,  1297,   685,  1209,   410,  1334,   692,   879,
     781,   174,  1335,   326,   892,   177,  1306,    65,  1536,   535,
     847,   437,   784,   785,   786,   787,   788,   789,   790,   791,
     792,   793,   794,   795,   796,   812,   946,  1082,  1082,  -283,
     812,   383,   812,   654,  -283,   388,   894,    66,  1390,   880,
     848,   849,    67,   823,  1391,    68,   388,   827,   815,   162,
     831,   395,   833,   396,   397,   163,    69,   837,   838,   928,
     208,   388,  1483,  1012,  1191,  1467,   211,  1527,  1528,   158,
     655,  1392,  1473,   870,   769,  1465,  1283,   777,    70,   770,
     778,    71,   164,    72,    73,  1126,  1127,   656,   159,   388,
     512,    74,   865,   481,   482,   483,   484,   485,   437,   160,
     165,  1060,  1082,  1062,   874,   943,   119,   486,   487,   488,
     489,   490,   491,   492,   493,   356,  1013,   494,  1137,    75,
     329,  1128,    76,   166,   740,   890,   330,   891,  1334,  1284,
    1285,   905,   388,   893,    77,   222,   687,   513,   514,  1353,
     958,   782,   515,  1454,   783,   959,   388,  1354,   516,   328,
    1221,   950,   331,    78,   332,  1194,   126,   127,   334,   131,
     132,   657,  1041,   923,  1042,   925,   335,   156,   223,   343,
     340,   224,   388,   388,  1206,   225,   226,   336,   227,   228,
     229,  1286,   167,   356,   999,   230,  1287,   115,   116,   413,
     512,   413,  1014,   413,   413,   439,   439,   445,  1043,   978,
    1044,   927,   388,    79,  1404,   981,   352,  1405,   117,   983,
     953,   222,   481,   482,   483,   484,   485,   364,   365,   231,
    1267,  1268,  1269,  1270,   232,   353,   486,   487,   488,   489,
     490,   491,   492,   493,   369,   954,   494,   513,   514,  1394,
     528,   529,   520,  1015,   223,   370,  1395,   224,   517,   944,
     371,   225,   226,   372,  1049,   228,   229,   373,  1056,   606,
    1057,   230,   345,   346,  1059,   955,   374,  1016,   395,  1017,
     396,   397,  1396,   547,   548,  1018,   972,  1019,   338,   339,
     375,  1020,  1021,   347,   119,   376,   438,   438,   481,   482,
     483,   484,   485,   378,  1253,   231,   975,   289,   379,   960,
     232,   961,   486,   487,   488,   489,   490,   491,   492,   493,
     392,   388,   494,   607,   380,   120,   481,   482,   483,   484,
     485,   291,   121,   122,   123,   364,   365,   884,   979,   980,
     486,   487,   488,   489,   490,   491,   492,   493,   987,  1260,
     494,   894,   991,  1022,   393,   993,   608,   816,   517,   817,
     998,   401,   134,   135,   398,   609,   481,   482,   483,   484,
     485,   136,   364,   365,  1105,    80,   115,   116,   403,  1011,
     486,   487,   488,   489,   490,   491,   492,   493,   414,   137,
     494,   416,   138,  1032,   139,   140,   415,   117,  1040,   178,
     423,   179,   180,   181,   182,   183,   184,   424,  1125,   914,
    1130,   425,   185,   186,   771,   187,  1138,   188,  1261,  1262,
    1263,  1264,   426,   492,   493,   915,  1307,   494,   427,   178,
     495,   179,   180,   181,   182,   183,   184,   481,   482,   483,
     484,   485,   185,   186,   745,   187,   746,   188,   748,   749,
     428,   486,   487,   488,   489,   490,   491,   492,   493,   501,
     957,   494,  1155,  1156,  1157,   674,   503,   189,   233,   610,
     611,   612,   613,   190,   496,  1308,  1309,  1310,   497,  1311,
     499,   675,   894,   916,  1200,   129,   130,   551,   552,   522,
    1312,   752,   281,   282,  1090,  1091,  1092,   189,  1093,   523,
    1094,  1133,   525,   190,   526,  1101,   577,   578,   527,  1118,
     531,  1144,  1103,   141,   481,   482,   483,   484,   485,  1109,
    1110,  1111,  1112,  1197,  1210,   530,   191,   192,   486,   487,
     488,   489,   490,   491,   492,   493,   676,   533,   494,   628,
     536,   677,   678,   540,   283,   345,   346,   714,   715,   679,
     897,   898,   900,   901,   933,   934,   191,   192,   629,   630,
     193,   194,   429,   430,   431,   432,  1226,  1227,   758,   759,
    1159,  1313,   541,   631,   632,   195,   633,   680,   196,  1095,
     542,   545,   197,   481,   482,   483,   484,   485,   546,   549,
     193,   194,   429,   430,   431,   432,   550,   486,   487,   488,
     489,   490,   491,   492,   493,   195,   554,   494,   196,   797,
     142,   681,   197,   553,   556,  1168,   563,   557,   917,  1169,
    1170,   212,   564,  1318,  1319,  1176,   213,  1320,  1321,  1322,
     558,   567,   798,   573,  1192,   565,  1185,   576,   799,   568,
     214,   574,   575,   800,   801,   579,  1195,  1196,   580,  1198,
     582,   581,   585,   594,   587,  1184,   600,  1203,   598,  1323,
    1204,   601,   599,   602,   918,   604,   615,   605,   614,   617,
     619,   481,   482,   483,   484,   485,   215,   620,   623,   919,
     621,  1234,   622,   626,   624,   486,   487,   488,   489,   490,
     491,   492,   493,   627,   636,   494,  1356,   920,  1358,   638,
     640,   641,   642,   643,   644,  1228,   752,  1230,   649,  1336,
     651,   921,   922,   652,   689,  1386,  1387,  1388,   690,  1232,
     694,   695,   696,   699,   711,  1240,   145,   718,  1101,   751,
     742,   750,  1298,   756,  1298,   755,   494,  1259,   767,   743,
     481,   482,   483,   484,   485,   198,   766,   757,   776,   802,
     760,   814,   768,   199,   486,   487,   488,   489,   490,   491,
     492,   493,   146,   147,   494,   818,   821,   824,  1210,   819,
    1442,   820,   822,   828,   829,   198,  1281,  1282,   834,  1176,
     832,   836,   841,   199,   842,   835,   859,   843,  1068,   935,
     178,   840,   179,   180,   181,   182,   183,   184,   845,   148,
     149,   150,   151,   185,   186,   853,   187,   854,   188,   858,
    1477,   861,   862,   863,   216,  1069,   867,   868,   871,   872,
     873,   875,  1357,   887,   876,  1210,   289,  1360,  1361,  1362,
     899,  1365,  1336,  1101,  1336,   877,   902,   903,  1507,   904,
     210,   906,  1511,   911,  1513,   907,   929,   910,   221,   930,
    1070,   942,   931,   236,  1144,   270,   932,   280,   189,   285,
     936,   286,   938,   302,   190,   941,   952,  1273,   217,  1522,
     951,   962,   963,   218,  1432,  1402,   964,   968,   969,   971,
     973,   975,   976,  1434,  1435,  1406,  1407,  1408,  1409,   982,
     984,  1526,   659,   985,   986,  1531,   219,   988,   990,   992,
     994,   995,   996,   997,  1452,  1453,  1000,   364,   365,  1001,
    1455,   220,  1002,  1003,  1455,  1004,  1005,   191,   192,  1071,
    1072,  1073,  1074,  1075,  1076,  1077,  1006,  1007,  1008,   660,
     989,  1009,  1037,  1010,  1476,   949,  1478,  1479,  1480,  1078,
    1482,  1484,  1079,  1026,  1045,  1497,  1034,  1050,  1038,  1039,
    1046,   193,   194,  1054,  1047,  1055,  1058,  1061,  1503,  1504,
    1505,  1063,  1064,   661,  1508,  1509,   195,  1065,   662,   196,
    1086,  1089,  1087,   197,  1515,   663,   664,   178,  1102,   179,
     180,   181,   182,   183,   184,  1104,  1113,  1114,   665,  1115,
     185,   186,   771,   187,  1116,   188,  1117,   666,   667,   668,
     669,  1524,   670,  1525,  1119,  1120,  1516,   178,  1121,   179,
     180,   181,   182,   183,   184,  1122,  1139,  1153,  1529,  1530,
     185,   186,  1532,   187,  1275,   188,  1533,  1132,  1149,  1140,
    1534,  1152,  1160,  1161,   178,  1162,   179,   180,   181,   182,
     183,   184,  1163,  1167,  1166,   189,  1175,   185,   186,  1243,
     187,   190,   188,   178,  1171,   179,   180,   181,   182,   183,
     184,  1188,  1190,  1235,  1242,  1246,   185,   186,  1186,   187,
    1271,   188,  1272,  1294,  1329,   189,  1363,  1187,  1384,  1199,
    1385,   190,  1403,  1438,  1444,  1439,  1446,   517,  1447,  1481,
    1193,  1449,  1290,  1342,  1201,   481,   482,   483,   484,   485,
    1202,  1205,   189,  1207,   191,   192,  1222,  1223,   190,   486,
     487,   488,   489,   490,   491,   492,   493,  1224,  1225,   494,
    1238,   189,  1239,  1245,  1247,  1266,  1274,   190,  1291,  1344,
    1295,  1327,  1345,  -283,   191,   192,   198,  -420,   193,   194,
    1346,  1347,  1399,  1411,   199,  1485,  1486,  1487,  1488,  1489,
    1490,  1491,  1492,   195,  1348,  1351,   196,  1359,  1369,  1389,
     197,   191,   192,  1398,  1410,  1433,  1436,  1443,   193,   194,
     700,   701,   702,   703,   704,   705,   706,   707,   708,  1213,
     191,   192,  1445,   195,  1474,  1496,   196,  1498,  1475,  1500,
     197,  1451,  1502,  1459,  1510,   193,   194,  1463,  1499,  1501,
    1506,   521,  1517,  1518,   481,   482,   483,   484,   485,  1521,
     195,  1519,  1520,   196,   193,   194,  1542,   197,   486,   487,
     488,   489,   490,   491,   492,   493,  1066,   637,   494,   195,
     650,  1052,   196,  1108,  1151,  1053,   197,   481,   482,   483,
     484,   485,  1179,  1067,   734,   908,   673,   948,  1400,   966,
    1466,   486,   487,   488,   489,   490,   491,   492,   493,  1099,
     433,   494,   481,   482,   483,   484,   485,  1468,   970,   967,
    1088,  1173,  1288,  1229,  1251,  1248,   486,   487,   488,   489,
     490,   491,   492,   493,  1437,  1457,   494,   481,   482,   483,
     484,   485,  1512,  1461,  1460,  1514,  1051,     0,     0,     0,
       0,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,     0,     0,     0,     0,     0,     0,   481,   482,
     483,   484,   485,   198,     0,     0,     0,     0,     0,     0,
       0,   199,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,     0,     0,     0,     0,     0,   481,   482,
     483,   484,   485,   198,     0,  -415,     0,     0,     0,     0,
       0,   199,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,     0,     0,     0,     0,     0,     0,     0,
     198,   719,   720,   721,   722,   723,   724,   725,   199,   726,
     727,   728,   729,   730,   481,   482,   483,   484,   485,   198,
       0,     0,     0,     0,     0,     0,     0,   199,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   481,
     482,   483,   484,   485,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,     0,     0,     0,     0,  1343,   481,
     482,   483,   484,   485,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   481,   482,   483,   484,   485,     0,
       0,     0,     0,     0,  1068,     0,     0,     0,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   481,
     482,   483,   484,   485,     0,     0,     0,     0,     0,     0,
       0,  1069,     0,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   481,   482,   483,   484,   485,     0,
       0,     0,   448,     0,     0,     0,     0,     0,   486,   487,
     488,   489,   490,   491,   492,   493,  1070,     0,   494,   481,
     482,   483,   484,   485,     0,     0,   956,     0,     0,     0,
     448,     0,     0,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,     0,     0,   481,   482,   483,   484,
     485,     0,     0,     0,   945,     0,     0,     0,     0,  1096,
     486,   487,   488,   489,   490,   491,   492,   493,   449,   450,
     494,     0,   451,   452,   222,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1180,  1071,  1072,  1073,  1074,  1075,
    1076,  1077,     0,     0,   287,     0,   449,   450,   453,     0,
     451,   452,   222,     0,     0,  1078,     0,   223,  1079,  1181,
     224,     0,     0,     0,   225,   226,     0,   288,   228,   229,
       0,     0,     0,     0,   230,   310,   311,   312,     0,   313,
     314,   454,     0,   289,     0,   223,     0,     0,   224,     0,
    1182,     0,   225,   226,     0,     0,   228,   229,     0,     0,
       0,     0,   230,     0,     0,     0,   290,   291,   231,   454,
       0,     0,     0,   232,     0,     0,     0,     0,     0,     0,
    1183,     0,     0,     0,     0,     0,     0,   455,   456,     0,
     457,   458,   459,   460,   461,     0,   231,     0,     0,     0,
       0,   232,     0,   481,   482,   483,   484,   485,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   486,   487,   488,
     489,   490,   491,   492,   493,     0,  1189,   494,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   719,   720,   721,
     722,   723,   724,   725,     0,   726,   727,   728,   729,   730,
       0,  1241,     0,     0,   471,   472,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,   473,   474,   475,   476,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   222,
       0,  1289,   471,   472,   237,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   473,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,     0,  1464,     0,  1277,     0,
       0,     0,   223,     0,     0,   224,     0,   222,     0,   225,
     226,     0,     0,   228,   229,     0,   292,     0,     0,   230,
       0,  1469,     0,     0,     0,   238,     0,     0,   239,     0,
     240,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,     0,     0,   224,     0,     0,  1470,   225,   226,   477,
     478,   228,   229,   231,     0,     0,  1233,   230,   232,     0,
       0,     0,     0,     0,  1370,     0,   241,     0,     0,     0,
     809,  1471,     0,   293,   294,   295,   242,   477,   478,     0,
       0,     0,   296,     0,     0,     0,     0,     0,     0,     0,
       0,   231,     0,     0,     0,     0,   232,   297,  1472,   481,
     482,   483,   484,   485,     0,  1412,     0,   222,  1371,     0,
       0,     0,   243,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,     0,   315,     0,     0,   244,   245,
       0,   246,   247,     0,   248,   249,   250,     0,   251,     0,
     223,   252,   253,   224,   254,   289,     0,   225,   226,     0,
    1027,   228,   229,   222,     0,     0,     0,   230,   255,   256,
       0,  1372,     0,   257,     0,   258,   259,     0,   260,   291,
       0,     0,   303,   261,     0,     0,     0,   262,   263,     0,
     264,   265,     0,   266,   267,     0,   223,     0,     0,   224,
    1413,   231,     0,   225,   226,     0,   232,   228,   229,     0,
       0,     0,     0,   230,     0,     0,     0,   222,   719,   720,
     721,   722,   723,   724,   725,     0,   726,   727,   728,   729,
     730,     0,     0,     0,   271,     0,  1028,     0,     0,   272,
       0,   273,   319,     0,     0,     0,     0,   231,     0,  1373,
     223,     0,   232,   224,     0,     0,     0,   225,   226,     4,
     304,   228,   229,     0,     0,     0,     0,   230,     0,     0,
       0,     0,     0,     0,  1414,  1374,   274,     0,  1375,  1376,
       5,     6,  1377,  1378,   320,  1379,     0,     0,     0,     0,
       0,     0,     0,  1380,  1381,     0,     0,     0,     0,     0,
       0,   231,   268,     0,     0,     0,   232,     0,     0,     0,
       0,     0,     0,     0,     7,     8,     0,     0,     0,  1415,
       0,  1416,  1382,  1417,  1418,  1419,  1420,  1421,  1422,     0,
       0,     0,     0,     0,     0,     9,     0,     0,  1423,  1424,
     275,     0,  1425,     0,     0,    10,     0,  1426,    11,     0,
      12,     0,     0,    13,     0,  1427,     0,     0,    14,    15,
      16,     0,     0,  1428,     0,    17,    18,  -421,  -421,  -421,
       0,   305,     0,     0,     0,     0,     0,     0,   481,   482,
     483,  -421,  -421,  -421,  -421,   490,   491,   492,   493,     0,
       0,   494,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,     0,     0,     0,     0,     0,     0,     0,
       0,  1029,  1030,     0,     0,     0,     0,     0,     0,  1429,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1031,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     321
};

static const yytype_int16 yycheck[] =
{
      79,   244,   245,   271,   199,   583,   143,   144,   199,   100,
     142,   102,   587,   104,   962,   240,     6,   108,   669,   110,
       7,    15,   113,   114,    20,    15,    16,    17,    18,    19,
     942,    22,    15,   258,     6,    15,    19,    18,    19,    19,
      18,    19,   267,    15,    16,    17,    18,   272,    28,   274,
      18,    19,    18,    26,    27,    29,    46,    15,    16,    17,
      18,    19,   115,   163,    27,    35,     6,    88,   137,    19,
      40,   217,  1081,   743,    83,    15,    16,    17,    18,    19,
       4,    15,    19,    88,    88,    19,   311,     3,   313,   885,
       0,    81,    15,    16,    17,    18,    19,   559,    40,   199,
      34,    35,    36,    37,  1187,    20,    46,    15,   162,   188,
      18,    19,     8,     9,    10,    11,    12,  1082,   363,   198,
     365,    15,    16,    17,    18,   225,    22,    23,    24,    25,
      26,    27,    28,    29,    84,    15,    32,  1252,   716,    19,
    1280,    81,   604,     3,    15,    16,    17,    18,    19,   249,
      18,    19,     3,    74,    34,    35,    36,    37,   201,   115,
     150,   151,   152,   153,   154,   155,   156,   304,   222,  1081,
     115,  1280,   318,   273,    15,    16,    17,    18,    15,    22,
     170,    19,    19,   173,     8,     9,    10,    11,    12,    32,
     290,   106,    15,   293,   294,   145,    19,   266,    22,    23,
      24,    25,    26,    27,    28,    29,   115,   215,    32,  1292,
     150,   151,   152,   153,   154,   155,   156,   354,    15,    15,
     289,   137,    19,    19,  1233,   357,   358,   164,   360,   361,
     170,    35,   332,   173,   197,   503,    40,  1352,    34,    35,
      36,    37,   251,     8,     9,    10,    11,    12,    15,    89,
     286,   683,    19,  1049,   686,  1167,   688,    22,    23,    24,
      25,    26,    27,    28,    29,  1405,  1231,    32,     8,     9,
      10,    11,    12,   120,   121,   122,   123,   282,   282,   379,
     285,   285,    22,    23,    24,    25,    26,    27,    28,    29,
     390,   131,    32,   536,   215,   364,  1405,   307,     8,     9,
      10,    11,    12,   138,    20,   313,   176,   350,   351,   388,
     535,   364,    22,    23,    24,    25,    26,    27,    28,    29,
    1329,  1233,    32,   974,   549,   361,   347,   348,  1277,   554,
     409,   556,   266,   558,   202,   560,   415,    53,   563,   564,
     565,    19,  1290,   110,   423,   424,   425,   426,   427,   299,
      15,   178,     3,    78,    78,   365,   364,    15,   437,   309,
     310,    19,   232,    19,   607,  1277,   609,   363,   359,   359,
      35,    19,   366,   360,   364,    40,   359,   602,   361,   359,
      74,  1330,   625,   364,    40,   363,   366,   359,   362,   114,
     363,   119,   364,   363,   619,    19,   364,     3,   364,   234,
     212,   359,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   515,  1086,  1329,  1330,   359,
     520,   363,   522,    74,   364,   359,   669,    33,   331,   154,
     242,   243,    38,   533,   337,    41,   359,   537,   517,   106,
     540,    15,   542,    17,    18,   112,    52,   547,   548,   692,
      19,   359,   110,    84,  1105,  1404,   363,   294,   295,    20,
     111,   364,  1410,  1038,   360,   359,    87,   365,    74,   365,
     368,    77,    38,    79,    80,   266,   267,   128,    39,   359,
      40,    87,   582,     8,     9,    10,    11,    12,   359,    50,
      56,   923,  1404,   925,   594,   738,    20,    22,    23,    24,
      25,    26,    27,    28,    29,    19,   137,    32,   304,   115,
       3,   302,   118,    79,   361,   615,     3,   617,   359,   140,
     141,   658,   359,   623,   130,    41,    40,    87,    88,   289,
     360,   365,    92,   330,   368,   365,   359,   297,    98,   120,
    1152,   365,   123,   149,    61,  1123,     7,     8,     3,    10,
      11,   202,   101,   685,   103,   687,     3,    18,    74,   363,
       3,    77,   359,   359,  1142,    81,    82,    74,    84,    85,
      86,   192,   138,    19,   842,    91,   197,    19,    20,   406,
      40,   408,   213,   410,   411,   776,   777,   782,   101,   814,
     103,   691,   359,   199,   362,   820,     3,   365,    40,   824,
     365,    41,     8,     9,    10,    11,    12,    18,    19,   125,
    1222,  1223,  1224,  1225,   130,     3,    22,    23,    24,    25,
      26,    27,    28,    29,     3,   365,    32,    87,    88,   331,
     218,   219,    92,   264,    74,     3,   338,    77,   198,   739,
       3,    81,    82,     3,   887,    85,    86,     3,   916,   155,
     918,    91,    19,    20,   922,   365,     3,   288,    15,   290,
      17,    18,   364,   222,   223,   296,   803,   298,   129,   130,
       3,   302,   303,    40,    20,    15,   776,   777,     8,     9,
      10,    11,    12,     3,   363,   125,   365,   100,    22,   768,
     130,   770,    22,    23,    24,    25,    26,    27,    28,    29,
     361,   359,    32,   209,    57,    51,     8,     9,    10,    11,
      12,   124,    58,    59,    60,    18,    19,    20,   818,   819,
      22,    23,    24,    25,    26,    27,    28,    29,   828,   274,
      32,   974,   832,   364,   126,   835,   242,   520,   198,   522,
     840,    19,   106,   107,   101,   251,     8,     9,    10,    11,
      12,   115,    18,    19,    20,   361,    19,    20,   361,   859,
      22,    23,    24,    25,    26,    27,    28,    29,    29,   133,
      32,   197,   136,   864,   138,   139,   359,    40,   878,    13,
     359,    15,    16,    17,    18,    19,    20,   359,  1013,     3,
    1015,   359,    26,    27,    28,    29,  1021,    31,   343,   344,
     345,   346,   359,    28,    29,    19,   219,    32,   359,    13,
     101,    15,    16,    17,    18,    19,    20,     8,     9,    10,
      11,    12,    26,    27,   406,    29,   408,    31,   410,   411,
     359,    22,    23,    24,    25,    26,    27,    28,    29,    19,
     365,    32,  1042,  1043,  1044,     3,    78,    81,   364,   355,
     356,   357,   358,    87,   363,   268,   269,   270,   363,   272,
     363,    19,  1105,    77,  1132,   128,   129,   232,   233,    92,
     283,   950,   312,   313,   953,   954,   955,    81,   957,    20,
     959,  1018,   361,    87,   361,   964,   314,   315,   363,   989,
      20,  1028,   971,   257,     8,     9,    10,    11,    12,    94,
      95,    96,    97,  1128,  1147,   220,   140,   141,    22,    23,
      24,    25,    26,    27,    28,    29,    74,    92,    32,    70,
     122,    79,    80,    67,   364,    19,    20,    54,    55,    87,
     364,   365,   364,   365,   364,   365,   140,   141,    89,    90,
     174,   175,   176,   177,   178,   179,  1162,  1163,   419,   420,
    1050,   364,   205,   104,   105,   189,   107,   115,   192,   365,
      67,   203,   196,     8,     9,    10,    11,    12,   211,   215,
     174,   175,   176,   177,   178,   179,   217,    22,    23,    24,
      25,    26,    27,    28,    29,   189,   236,    32,   192,   159,
     354,   149,   196,   232,   239,  1074,   215,   241,   212,  1078,
    1079,    64,   254,   328,   329,  1084,    69,   332,   333,   334,
     246,   361,   182,   361,  1114,   252,  1095,    74,   188,   363,
      83,   363,   363,   193,   194,   361,  1126,  1127,   363,  1129,
      67,   363,    20,    67,   363,   365,   363,  1137,   361,   364,
    1140,   363,   361,   291,   258,    74,    74,   361,   361,    67,
      70,     8,     9,    10,    11,    12,   119,   361,    67,   273,
     361,   363,   361,   361,    20,    22,    23,    24,    25,    26,
      27,    28,    29,   361,     3,    32,  1301,   291,  1303,     3,
       3,    19,     3,     3,     3,  1164,  1165,  1166,     3,  1280,
       3,   305,   306,     3,     3,  1320,  1321,  1322,     3,   361,
     116,   116,     3,    20,   361,  1184,    70,   361,  1187,    15,
     361,    14,  1249,   197,  1251,    26,    32,  1217,    15,   359,
       8,     9,    10,    11,    12,   359,    19,    27,     7,    19,
      29,    99,   365,   367,    22,    23,    24,    25,    26,    27,
      28,    29,   106,   107,    32,    67,   361,   244,  1391,    67,
    1375,    46,   361,   202,    30,   359,  1235,  1236,   361,  1238,
      67,   212,   361,   367,    78,    67,    92,   361,    19,   360,
      13,    67,    15,    16,    17,    18,    19,    20,   361,   143,
     144,   145,   146,    26,    27,   361,    29,   361,    31,   361,
    1415,    19,   361,   361,   257,    46,   361,   361,   361,   361,
     361,   361,  1302,   209,   361,  1448,   100,  1307,  1308,  1309,
       3,  1311,  1403,  1292,  1405,   361,     3,    19,  1443,    15,
      86,    19,  1447,    20,  1449,    19,    15,    19,    94,    15,
      81,   363,   361,    99,  1371,   101,   361,   103,    81,   105,
      20,   107,   361,   109,    87,   361,    27,   361,   311,  1474,
     360,     7,   365,   316,  1354,  1334,   365,    15,    18,   359,
      27,   365,    93,  1363,  1364,  1344,  1345,  1346,  1347,   361,
     361,  1496,     3,   361,   361,  1500,   339,    19,   361,   361,
     361,   361,   361,   361,  1384,  1385,   361,    18,    19,   361,
    1390,   354,   361,   361,  1394,   361,   361,   140,   141,   150,
     151,   152,   153,   154,   155,   156,   361,   361,   361,    40,
     202,   361,   364,   361,  1414,   360,  1416,  1417,  1418,   170,
    1420,  1421,   173,   361,   364,  1425,   361,   301,   361,   361,
     361,   174,   175,     3,   361,     3,    15,     3,  1438,  1439,
    1440,     3,   202,    74,  1444,  1445,   189,   202,    79,   192,
     361,    27,   360,   196,  1454,    86,    87,    13,   365,    15,
      16,    17,    18,    19,    20,   116,   361,   365,    99,   361,
      26,    27,    28,    29,   361,    31,   361,   108,   109,   110,
     111,  1481,   113,  1483,   361,   361,  1465,    13,   361,    15,
      16,    17,    18,    19,    20,   361,   361,    20,  1498,  1499,
      26,    27,  1502,    29,   361,    31,  1506,   291,   361,   307,
    1510,   361,     3,     3,    13,    15,    15,    16,    17,    18,
      19,    20,    15,   359,    22,    81,   361,    26,    27,    28,
      29,    87,    31,    13,   364,    15,    16,    17,    18,    19,
      20,    15,    15,    22,     7,   202,    26,    27,   360,    29,
       3,    31,     3,    15,   172,    81,   217,   365,   331,   363,
     331,    87,     7,   331,    67,   323,   211,   198,   200,   217,
     361,   200,   359,   361,   363,     8,     9,    10,    11,    12,
     363,   363,    81,   363,   140,   141,   361,   361,    87,    22,
      23,    24,    25,    26,    27,    28,    29,   361,   361,    32,
     365,    81,   361,   364,   361,   361,   360,    87,   360,   359,
     363,   360,   359,   364,   140,   141,   359,   360,   174,   175,
     359,   359,   364,   360,   367,   274,   275,   276,   277,   278,
     279,   280,   281,   189,   361,   361,   192,   361,   361,   361,
     196,   140,   141,   361,   365,   361,   318,   322,   174,   175,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    20,
     140,   141,   326,   189,   291,   276,   192,   293,   363,   274,
     196,   361,   319,   361,    92,   174,   175,   361,   301,   361,
     319,   229,   361,   361,     8,     9,    10,    11,    12,   360,
     189,   361,   361,   192,   174,   175,   361,   196,    22,    23,
      24,    25,    26,    27,    28,    29,   934,   328,    32,   189,
     347,   898,   192,   975,  1038,   901,   196,     8,     9,    10,
      11,    12,  1086,   941,   400,   664,   354,   744,  1329,   776,
    1403,    22,    23,    24,    25,    26,    27,    28,    29,   963,
     198,    32,     8,     9,    10,    11,    12,  1405,   782,   777,
     950,  1082,  1238,  1165,  1202,  1194,    22,    23,    24,    25,
      26,    27,    28,    29,  1371,  1391,    32,     8,     9,    10,
      11,    12,  1448,  1395,  1394,  1450,   889,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,
      10,    11,    12,   359,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   367,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,     8,     9,
      10,    11,    12,   359,    -1,   361,    -1,    -1,    -1,    -1,
      -1,   367,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     359,   157,   158,   159,   160,   161,   162,   163,   367,   165,
     166,   167,   168,   169,     8,     9,    10,    11,    12,   359,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   367,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    -1,    -1,    -1,    -1,   361,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,     8,     9,    10,    11,    12,    -1,
      -1,    -1,     5,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    81,    -1,    32,     8,
       9,    10,    11,    12,    -1,    -1,   360,    -1,    -1,    -1,
       5,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    -1,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,   360,    -1,    -1,    -1,    -1,   360,
      22,    23,    24,    25,    26,    27,    28,    29,    71,    72,
      32,    -1,    75,    76,    41,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   360,   150,   151,   152,   153,   154,
     155,   156,    -1,    -1,    61,    -1,    71,    72,   101,    -1,
      75,    76,    41,    -1,    -1,   170,    -1,    74,   173,   360,
      77,    -1,    -1,    -1,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    -1,    91,    64,    65,    66,    -1,    68,
      69,   134,    -1,   100,    -1,    74,    -1,    -1,    77,    -1,
     360,    -1,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    91,    -1,    -1,    -1,   123,   124,   125,   134,
      -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
     360,    -1,    -1,    -1,    -1,    -1,    -1,   180,   181,    -1,
     183,   184,   185,   186,   187,    -1,   125,    -1,    -1,    -1,
      -1,   130,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,   360,    32,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,   166,   167,   168,   169,
      -1,   360,    -1,    -1,   247,   248,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   259,   260,   261,   262,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      -1,   360,   247,   248,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   259,   260,   261,   262,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   360,    -1,   363,    -1,
      -1,    -1,    74,    -1,    -1,    77,    -1,    41,    -1,    81,
      82,    -1,    -1,    85,    86,    -1,   283,    -1,    -1,    91,
      -1,   360,    -1,    -1,    -1,    97,    -1,    -1,   100,    -1,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      74,    -1,    -1,    77,    -1,    -1,   360,    81,    82,   352,
     353,    85,    86,   125,    -1,    -1,   171,    91,   130,    -1,
      -1,    -1,    -1,    -1,   116,    -1,   138,    -1,    -1,    -1,
      19,   360,    -1,   340,   341,   342,   148,   352,   353,    -1,
      -1,    -1,   349,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   125,    -1,    -1,    -1,    -1,   130,   364,   360,     8,
       9,    10,    11,    12,    -1,    60,    -1,    41,   160,    -1,
      -1,    -1,   184,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    -1,   364,    -1,    -1,   200,   201,
      -1,   203,   204,    -1,   206,   207,   208,    -1,   210,    -1,
      74,   213,   214,    77,   216,   100,    -1,    81,    82,    -1,
      84,    85,    86,    41,    -1,    -1,    -1,    91,   230,   231,
      -1,   213,    -1,   235,    -1,   237,   238,    -1,   240,   124,
      -1,    -1,    60,   245,    -1,    -1,    -1,   249,   250,    -1,
     252,   253,    -1,   255,   256,    -1,    74,    -1,    -1,    77,
     145,   125,    -1,    81,    82,    -1,   130,    85,    86,    -1,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    41,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,   166,   167,   168,
     169,    -1,    -1,    -1,   258,    -1,   160,    -1,    -1,   263,
      -1,   265,    66,    -1,    -1,    -1,    -1,   125,    -1,   291,
      74,    -1,   130,    77,    -1,    -1,    -1,    81,    82,    41,
     138,    85,    86,    -1,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    -1,    -1,    -1,   219,   317,   300,    -1,   320,   321,
      62,    63,   324,   325,   108,   327,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   335,   336,    -1,    -1,    -1,    -1,    -1,
      -1,   125,   364,    -1,    -1,    -1,   130,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,    97,    -1,    -1,    -1,   264,
      -1,   266,   364,   268,   269,   270,   271,   272,   273,    -1,
      -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,   283,   284,
     364,    -1,   287,    -1,    -1,   127,    -1,   292,   130,    -1,
     132,    -1,    -1,   135,    -1,   300,    -1,    -1,   140,   141,
     142,    -1,    -1,   308,    -1,   147,   148,     8,     9,    10,
      -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,
      10,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   335,   336,    -1,    -1,    -1,    -1,    -1,    -1,   364,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   364,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     364
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   370,   371,    41,    62,    63,    96,    97,   117,
     127,   130,   132,   135,   140,   141,   142,   147,   148,   392,
     393,   394,   395,   396,   397,   445,   446,   447,   448,   450,
     451,   452,   455,   458,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   570,   571,   572,   573,   574,   575,
     576,   577,   629,   631,     0,     3,    33,    38,    41,    52,
      74,    77,    79,    80,    87,   115,   118,   130,   149,   199,
     361,   373,   382,   388,   391,   400,   402,   405,   407,   411,
     412,   414,   415,   422,   430,   431,   485,   487,   497,   536,
     537,   538,   539,   579,   580,   581,   586,   614,   615,   623,
     624,   630,   632,   633,   634,    19,    20,    40,   483,    20,
      51,    58,    59,    60,   398,     3,   483,   483,   115,   128,
     129,   483,   483,     3,   106,   107,   115,   133,   136,   138,
     139,   257,   354,   115,   115,    70,   106,   107,   143,   144,
     145,   146,    15,    35,    40,   472,   483,    19,    20,    39,
      50,   384,   106,   112,    38,    56,    79,   138,   389,   390,
      19,    78,    19,    74,   119,    20,   106,    19,    13,    15,
      16,    17,    18,    19,    20,    26,    27,    29,    31,    81,
      87,   140,   141,   174,   175,   189,   192,   196,   359,   367,
     502,   515,   520,   523,   524,   525,   527,   529,    19,   416,
     416,   363,    64,    69,    83,   119,   257,   311,   316,   339,
     354,   416,    41,    74,    77,    81,    82,    84,    85,    86,
      91,   125,   130,   364,   417,   433,   416,    46,    97,   100,
     102,   138,   148,   184,   200,   201,   203,   204,   206,   207,
     208,   210,   213,   214,   216,   230,   231,   235,   237,   238,
     240,   245,   249,   250,   252,   253,   255,   256,   364,   417,
     416,   258,   263,   265,   300,   364,   417,   540,   541,   542,
     416,   312,   313,   364,   417,   416,   416,    61,    84,   100,
     123,   124,   283,   340,   341,   342,   349,   364,   417,   440,
     442,   443,   416,    60,   138,   249,   364,   417,   625,   628,
      64,    65,    66,    68,    69,   364,   401,   404,   417,    66,
     108,   364,   403,   417,    35,    40,   363,   434,   398,     3,
       3,   398,    61,   399,     3,     3,    74,   460,   483,   483,
       3,    35,    40,   363,   437,    19,    20,    40,   484,     3,
     137,   456,     3,     3,   453,   459,    19,    84,   145,   299,
     309,   310,   449,   449,    18,    19,   375,   377,   377,     3,
       3,     3,     3,     3,     3,     3,    15,   473,     3,    22,
      57,   383,    40,   363,   385,   434,    15,    19,   359,   372,
      20,    53,   361,   126,   410,    15,    17,    18,   101,   406,
     486,    19,   408,   361,   437,   498,    15,    19,    28,   359,
     366,   519,   521,   527,    29,   359,   197,    27,   197,    15,
     366,   522,   529,   359,   359,   359,   359,   359,   359,   176,
     177,   178,   179,   509,   529,    16,    17,   359,   372,   502,
     503,   507,   510,   511,   513,   515,   516,   517,     5,    71,
      72,    75,    76,   101,   134,   180,   181,   183,   184,   185,
     186,   187,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   247,   248,   259,   260,   261,   262,   352,   353,   528,
     635,     8,     9,    10,    11,    12,    22,    23,    24,    25,
      26,    27,    28,    29,    32,   101,   363,   363,   413,   363,
     434,    19,   421,    78,   372,    34,    35,    36,    37,   372,
     374,   432,    40,    87,    88,    92,    98,   198,   418,   494,
      92,   418,    92,    20,   437,   361,   361,   363,   218,   219,
     220,    20,   374,    92,   138,   234,   122,   202,   375,   375,
      67,   205,    67,   361,   372,   203,   211,   222,   223,   215,
     217,   232,   233,   232,   236,   374,   239,   241,   246,    74,
     215,    83,   251,   215,   254,   252,   374,   361,   363,   406,
     374,   372,   374,   361,   363,   363,    74,   314,   315,   361,
     363,   363,    67,   621,   622,    20,   372,   363,    88,   347,
     348,   616,   372,   372,    67,   201,   350,   351,   361,   361,
     363,   363,   291,   377,    74,   361,   155,   209,   242,   251,
     355,   356,   357,   358,   361,    74,   374,    67,   374,    70,
     361,   361,   361,    67,    20,   381,   361,   361,    70,    89,
      90,   104,   105,   107,   435,   436,     3,   399,     3,   372,
       3,    19,     3,     3,     3,    89,   131,   438,   439,     3,
     484,     3,     3,     3,    74,   111,   128,   202,   457,     3,
      40,    74,    79,    86,    87,    99,   108,   109,   110,   111,
     113,   377,   454,   494,     3,    19,    74,    79,    80,    87,
     115,   149,   449,   449,   578,    40,   449,    40,   449,     3,
       3,    29,   362,   379,   116,   116,     3,    18,   372,    20,
      41,    42,    43,    44,    45,    46,    47,    48,    49,   386,
     387,   361,   529,   372,    54,    55,   428,   429,   361,   157,
     158,   159,   160,   161,   162,   163,   165,   166,   167,   168,
     169,   488,   489,   490,   492,   496,   120,   121,   122,   123,
     361,   409,   361,   359,   495,   521,   521,   529,   521,   521,
      14,    15,   529,   533,   534,    26,   197,    27,   522,   522,
      29,   529,   529,   529,   529,   529,    19,    15,   365,   360,
     365,    28,   505,   506,   509,   529,     7,   365,   368,    26,
      27,   363,   365,   368,   529,   529,   529,   529,   529,   529,
     529,   529,   529,   529,   529,   529,   529,   159,   182,   188,
     193,   194,    19,   115,   364,   406,   423,   426,   427,    19,
     492,   493,   372,   420,    99,   529,   420,   420,    67,    67,
      46,   361,   361,   372,   244,   374,   375,   372,   202,    30,
     376,   372,    67,   372,   361,    67,   212,   372,   372,   374,
      67,   361,    78,   361,   374,   361,   374,   212,   242,   243,
     374,   421,   374,   361,   361,   374,   374,   374,   361,    92,
     543,    19,   361,   361,   585,   372,   427,   361,   361,   441,
     442,   361,   361,   361,   372,   361,   361,   361,    78,   114,
     154,   444,   374,   421,    20,   375,   375,   209,   626,   627,
     372,   372,   374,   372,   375,   377,   378,   364,   365,     3,
     364,   365,     3,    19,    15,   377,    19,    19,   493,   378,
      19,    20,   569,   569,     3,    19,    77,   212,   258,   273,
     291,   305,   306,   449,   569,   449,   569,   372,   375,    15,
      15,   361,   361,   364,   365,   360,    20,   427,   361,    19,
     164,   361,   363,   375,   372,   360,   489,   491,   496,   360,
     365,   360,    27,   365,   365,   365,   360,   365,   360,   365,
     529,   529,     7,   365,   365,    18,   503,   511,    15,    18,
     516,   359,   377,    27,   425,   365,    93,   419,   374,   372,
     372,   374,   361,   374,   361,   361,   361,   372,    19,   202,
     361,   372,   361,   372,   361,   361,   361,   361,   372,   406,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   372,    84,   137,   213,   264,   288,   290,   296,   298,
     302,   303,   364,   544,   551,   554,   361,    84,   160,   335,
     336,   364,   417,   582,   361,   363,   620,   364,   361,   361,
     372,   101,   103,   101,   103,   364,   361,   361,   376,   375,
     301,   626,   436,   439,     3,     3,   406,   406,    15,   406,
     569,     3,   569,     3,   202,   202,   387,   490,    19,    46,
      81,   150,   151,   152,   153,   154,   155,   156,   170,   173,
     499,   500,   525,   526,   530,   535,   361,   360,   533,    27,
     529,   529,   529,   529,   529,   365,   360,   505,   529,   506,
     508,   529,   365,   529,   116,    20,   378,   424,   426,    94,
      95,    96,    97,   361,   365,   361,   361,   361,   372,   361,
     361,   361,   361,   564,   568,   374,   266,   267,   302,   266,
     374,   545,   291,   377,   547,   548,   546,   304,   374,   361,
     307,   565,   587,   594,   377,   595,   600,   583,   584,   361,
     619,   441,   361,    20,   380,   380,   380,   380,   376,   372,
       3,     3,    15,    15,    22,   359,    22,   359,   529,   529,
     529,   364,   535,   528,   635,   361,   529,   531,   532,   491,
     360,   360,   360,   360,   365,   529,   360,   365,    15,   360,
      15,   378,   372,   361,   427,   372,   372,   374,   372,   363,
     406,   363,   363,   372,   372,   363,   427,   363,   599,   363,
     375,   601,   606,    20,   363,   607,   612,   215,   313,   364,
     618,   444,   361,   361,   361,   361,   460,   460,   529,   534,
     529,   525,   361,   171,   363,    22,    22,    32,   365,   361,
     529,   360,     7,    28,   508,   364,   202,   361,   565,   556,
     549,   556,   552,   363,   593,   598,   597,   602,   608,   372,
     274,   343,   344,   345,   346,   617,   361,   444,   444,   444,
     444,     3,     3,   361,   360,   361,   635,   363,   501,   535,
     518,   529,   529,    87,   140,   141,   192,   197,   532,   360,
     359,   360,     7,   360,    15,   363,   567,   364,   377,   557,
     558,   137,   266,   289,   364,   550,   364,   219,   268,   269,
     270,   272,   283,   364,   440,   553,   592,   591,   328,   329,
     332,   333,   334,   364,   596,   605,   611,   360,   499,   172,
       6,    15,    16,    17,   359,   364,   502,   504,   507,   510,
     512,   514,   361,   361,   359,   359,   359,   359,   361,   505,
     508,   361,   566,   289,   297,   559,   374,   372,   374,   361,
     372,   372,   372,   217,   110,   372,    88,   282,   285,   361,
     116,   160,   213,   291,   317,   320,   321,   324,   325,   327,
     335,   336,   364,   588,   331,   331,   374,   374,   374,   361,
     331,   337,   364,   603,   331,   338,   364,   609,   361,   364,
     501,   499,   529,     7,   362,   365,   529,   529,   529,   529,
     365,   360,    60,   145,   219,   264,   266,   268,   269,   270,
     271,   272,   273,   283,   284,   287,   292,   300,   308,   364,
     440,   555,   372,   361,   372,   372,   318,   600,   331,   323,
     217,   318,   374,   322,    67,   326,   211,   200,   589,   200,
     590,   361,   372,   372,   330,   372,   613,   601,   604,   361,
     613,   607,   610,   361,   360,   359,   504,   499,   512,   360,
     360,   360,   360,   505,   291,   363,   372,   374,   372,   372,
     372,   217,   372,   110,   372,   274,   275,   276,   277,   278,
     279,   280,   281,    88,   282,   285,   276,   372,   293,   301,
     274,   361,   319,   372,   372,   372,   319,   374,   372,   372,
      92,   374,   606,   374,   612,   372,   529,   361,   361,   361,
     361,   360,   374,   560,   372,   372,   374,   294,   295,   372,
     372,   374,   372,   372,   372,    18,   364,   561,   562,   563,
     286,   361,   361
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 669 "cf-parse.y"
    { return 0; ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 670 "cf-parse.y"
    { return 0; ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 683 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 684 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 690 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 694 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 703 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 704 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 705 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 706 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 707 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 708 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 715 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 722 "cf-parse.y"
    { (yyval.iface) = NULL; ;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 723 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 727 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 735 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 739 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 743 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 750 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 758 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 759 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 765 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 774 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 775 "cf-parse.y"
    { (yyval.t) = bird_name; ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 779 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 784 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 785 "cf-parse.y"
    { (yyval.g) = stderr; ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 789 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 790 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 794 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 795 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 799 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 800 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 801 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 802 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 803 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 804 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 805 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 806 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 807 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 813 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 814 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 823 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 824 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 825 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 826 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 829 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 830 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 831 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 832 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; ;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 844 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 847 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 854 "cf-parse.y"
    { cmd_reconfig_confirm(); ;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 857 "cf-parse.y"
    { cmd_reconfig_undo(); ;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 860 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); ;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 863 "cf-parse.y"
    { cmd_shutdown(); ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 866 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 871 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 872 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 873 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 881 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 886 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 887 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 891 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 898 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 904 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 909 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 913 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 927 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 941 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 942 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 946 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 948 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 967 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 968 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 969 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 970 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 977 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 978 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 982 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 990 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 996 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1010 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1011 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1015 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1021 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1025 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1037 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1041 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1042 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1043 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1044 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1045 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1046 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1047 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1048 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); ;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1049 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1050 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1051 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1052 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1056 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 1058 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1059 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1063 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 1064 "cf-parse.y"
    { (yyval.i) = PLA_WARN; ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 1065 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1066 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; ;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1067 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 1071 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1080 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1088 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 1089 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 1097 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1105 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1106 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1107 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1111 "cf-parse.y"
    { this_ipn->positive = 1; ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1112 "cf-parse.y"
    { this_ipn->positive = 0; ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 1125 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1140 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1153 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1167 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1168 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1169 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1174 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1178 "cf-parse.y"
    { (yyval.i) = D_STATES; ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1179 "cf-parse.y"
    { (yyval.i) = D_ROUTES; ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1180 "cf-parse.y"
    { (yyval.i) = D_FILTERS; ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1181 "cf-parse.y"
    { (yyval.i) = D_IFACES; ;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1182 "cf-parse.y"
    { (yyval.i) = D_EVENTS; ;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1183 "cf-parse.y"
    { (yyval.i) = D_PACKETS; ;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1189 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1190 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1191 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1196 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1200 "cf-parse.y"
    { (yyval.i) = MD_STATES; ;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1201 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1222 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1240 "cf-parse.y"
    { ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1241 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1242 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1243 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1244 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1245 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1254 "cf-parse.y"
    { cmd_show_status(); ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1257 "cf-parse.y"
    { cmd_show_memory(); ;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1260 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1263 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1267 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1271 "cf-parse.y"
    { if_show(); ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1274 "cf-parse.y"
    { if_show_summary(); ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1278 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1281 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->table = config->master_rtc->table;
   ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1287 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1293 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1300 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1305 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1310 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1315 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1319 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1323 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1327 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1337 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1345 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1349 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1356 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1357 "cf-parse.y"
    { (yyval.i) = 2; ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1363 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1366 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1373 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1380 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1384 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1392 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1393 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1394 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1400 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1403 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1406 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1407 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1408 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; ;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1409 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1410 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; ;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1411 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1412 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); ;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1417 "cf-parse.y"
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   ;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1422 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1431 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1438 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1445 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1453 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); ;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1455 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1457 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1459 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1461 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); ;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1463 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); ;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1465 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); ;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1467 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1473 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1474 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1479 "cf-parse.y"
    { (yyval.i) = 4096; ;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1480 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1487 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); ;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1489 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); ;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1491 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); ;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1493 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); ;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1495 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); ;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1497 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); ;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1501 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1505 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1508 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); ;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1511 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; ;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1512 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; ;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1513 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; ;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1517 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; ;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1518 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; ;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1519 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; ;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1527 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); ;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1528 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   ;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1537 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); ;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1541 "cf-parse.y"
    { (yyval.i) = T_INT; ;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1542 "cf-parse.y"
    { (yyval.i) = T_BOOL; ;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1543 "cf-parse.y"
    { (yyval.i) = T_IP; ;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1544 "cf-parse.y"
    { (yyval.i) = T_PREFIX; ;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1545 "cf-parse.y"
    { (yyval.i) = T_PAIR; ;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1546 "cf-parse.y"
    { (yyval.i) = T_QUAD; ;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1547 "cf-parse.y"
    { (yyval.i) = T_EC; ;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1548 "cf-parse.y"
    { (yyval.i) = T_STRING; ;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1549 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; ;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1550 "cf-parse.y"
    { (yyval.i) = T_PATH; ;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1551 "cf-parse.y"
    { (yyval.i) = T_CLIST; ;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1552 "cf-parse.y"
    { (yyval.i) = T_ECLIST; ;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1553 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1574 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1585 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1586 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1593 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1594 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1601 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   ;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1610 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1618 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  ;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1642 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1643 "cf-parse.y"
    { (yyval.s)=NULL; ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1647 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1660 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1663 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1676 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1677 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; ;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1680 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); ;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1681 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); ;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1685 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   ;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1688 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1697 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); ;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1710 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1711 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1712 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1713 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1717 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1718 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1719 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); ;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1720 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1721 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); ;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1725 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); ;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1728 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); ;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1729 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); ;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 1730 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; ;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1734 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   ;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 1737 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), (yyvsp[(8) - (11)].i), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(10) - (11)].i)); 
   ;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 1746 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); ;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 1749 "cf-parse.y"
    { (yyval.i) = EC_RT; ;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 1750 "cf-parse.y"
    { (yyval.i) = EC_RO; ;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 1751 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); ;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 1752 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; ;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 1756 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 1757 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); ;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 1758 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); ;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 1764 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); ;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 1765 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); ;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 1771 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 1772 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 1777 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 1782 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); ;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 1786 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 1793 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 1794 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 1795 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; ;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 1796 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   ;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 1803 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 1804 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 1807 "cf-parse.y"
    { (yyval.e) = NULL; ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 1808 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 1815 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 ;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 1827 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 1828 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 1832 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 1833 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 1837 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 1838 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 1839 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; ;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 1840 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 1841 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 1845 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 1846 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 1847 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 1851 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 1852 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 1853 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 1854 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 1855 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 1856 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 1857 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); ;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 1858 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 1859 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); ;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 1860 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 1861 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; ;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 1865 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); ;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 1866 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); ;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 1880 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 1903 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_QUAD:
       case SYM_VARIABLE | T_EC:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
       case SYM_VARIABLE | T_ECLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 1939 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; ;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 1941 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 1942 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ ;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 1943 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ ;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 1944 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); ;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 1945 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; ;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 1946 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); ;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 1947 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest);   (yyval.x)->a1.i = 1; ;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 1951 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 1952 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 1953 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 1954 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 1955 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 1956 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 1957 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 1958 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 1959 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 1960 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 1961 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 1962 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 1963 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 1964 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 1965 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 1966 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 1968 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 1969 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 1970 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 1972 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; ;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 1974 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 1976 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 1978 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 1979 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 1980 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 1981 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 1982 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 1992 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; ;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 1993 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; ;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 1994 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; ;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 1995 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 1996 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; ;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 1997 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; ;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 1998 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; ;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 2000 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); ;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 2001 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); ;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 2006 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 2029 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 2030 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; ;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 2031 "cf-parse.y"
    { (yyval.i) = F_REJECT; ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 2032 "cf-parse.y"
    { (yyval.i) = F_ERROR; ;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 2033 "cf-parse.y"
    { (yyval.i) = F_NOP; ;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 2034 "cf-parse.y"
    { (yyval.i) = F_NONL; ;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 2038 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; ;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 2041 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 2042 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 2043 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 2051 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   ;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 2058 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 2067 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 2068 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 2072 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   ;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 2078 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   ;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 2088 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 2097 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   ;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 2103 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 2108 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 2115 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 2120 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   ;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 2126 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 2127 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); ;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 2128 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   ;}
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 2136 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); ;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 2137 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 2138 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 2139 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 2140 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 2146 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[(1) - (2)].i));
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 ;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 2169 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); ;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 2170 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); ;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 2171 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[(3) - (7)].a)) != !(yyvsp[(4) - (7)].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[(3) - (7)].a);
     BGP_CFG->iface = (yyvsp[(4) - (7)].iface);
     BGP_CFG->remote_as = (yyvsp[(6) - (7)].i);
   ;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 2181 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); ;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 2182 "cf-parse.y"
    { BGP_CFG->rr_client = 1; ;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 2183 "cf-parse.y"
    { BGP_CFG->rs_client = 1; ;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 2184 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 2185 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 2186 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 2187 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 2188 "cf-parse.y"
    { BGP_CFG->multihop = 64; ;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 2189 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); ;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 2190 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; ;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 2191 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; ;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 2192 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; ;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 2193 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; ;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 2194 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; ;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 2195 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; ;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 2196 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); ;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 2197 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 2198 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); ;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 2199 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); ;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 2200 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); ;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 2201 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); ;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 2202 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); ;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 2203 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); ;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 2204 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 2205 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 2206 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); ;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 2207 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); ;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 2208 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); ;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 2209 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 2210 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); ;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 2211 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 2212 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); ;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 2213 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
   ;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 2218 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); ;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 2219 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); ;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 2220 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); ;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 2221 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); ;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 2222 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); ;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 2233 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  ;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 2249 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); ;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 2250 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; ;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 2251 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); ;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 2252 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); ;}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 2256 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 ;}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 2271 "cf-parse.y"
    { ospf_area_finish(); ;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 2280 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ ;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 2281 "cf-parse.y"
    { this_area->type = OPT_N; ;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 2282 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 2283 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); ;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 2284 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); ;}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 2285 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); ;}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 2286 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); ;}
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 2287 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); ;}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 2288 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); ;}
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 2289 "cf-parse.y"
    { this_nets = &this_area->net_list; ;}
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 2290 "cf-parse.y"
    { this_nets = &this_area->enet_list; ;}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 2302 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   ;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 2316 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); ;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 2317 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 2318 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); ;}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 2322 "cf-parse.y"
    { ospf_iface_finish(); ;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 2323 "cf-parse.y"
    { ospf_iface_finish(); ;}
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 2332 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 2333 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 2334 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 2335 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 2336 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 2337 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 2338 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 2339 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 2340 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 2345 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 2366 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); ;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 2367 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 2368 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); ;}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 2369 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 2370 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 2371 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 2372 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 2373 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 2374 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 2375 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 2376 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 2377 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 2378 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 2379 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; ;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 2380 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; ;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 2381 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); ;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 2382 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 2383 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); ;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 2384 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; ;}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 2385 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 2386 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); ;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 2387 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); ;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 2389 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 2390 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 2391 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 2392 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; ;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 2393 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; ;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 2394 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); ;}
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 2406 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 ;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 2416 "cf-parse.y"
    { this_pref->hidden = 1; ;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 2417 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); ;}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 2430 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (2)].a);
   this_nbma->eligible=0;
 ;}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 2439 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=1;
 ;}
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 2449 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 2471 "cf-parse.y"
    { set_instance_id((yyvsp[(2) - (2)].i)); ;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 2485 "cf-parse.y"
    { ospf_iface_finish(); ;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 2490 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 2496 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); ;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 2499 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 2502 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 2507 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); ;}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 2510 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); ;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 2515 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); ;}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 2518 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); ;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 2522 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); ;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 2525 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   ;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 2528 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; ;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 2529 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32) ;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 2530 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ ;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 2531 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); ;}
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 2532 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 2533 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; ;}
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 2534 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 2535 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); ;}
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 2541 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  ;}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 2550 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   ;}
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 2555 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; ;}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 2556 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; ;}
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 2563 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, sizeof(struct radv_config), (yyvsp[(1) - (2)].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
;}
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 2574 "cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); ;}
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 2575 "cf-parse.y"
    { init_list(&radv_dns_list); ;}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 2575 "cf-parse.y"
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); ;}
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 2576 "cf-parse.y"
    { init_list(&radv_dns_list); ;}
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 2576 "cf-parse.y"
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); ;}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 2589 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
;}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 2605 "cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); ;}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 2606 "cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); ;}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 2607 "cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); ;}
    break;

  case 626:

/* Line 1455 of yacc.c  */
#line 2608 "cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); ;}
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 2609 "cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); ;}
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 2610 "cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Link MTU must be 0 or positive"); ;}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 2611 "cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); ;}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 2612 "cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Retrans timer must be 0 or positive"); ;}
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 2613 "cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 0) || ((yyvsp[(4) - (4)].i) > 255))  cf_error("Current hop limit must be in range 0-255"); ;}
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 2614 "cf-parse.y"
    { RADV_IFACE->default_lifetime = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 9000))  cf_error("Default lifetime must be in range 0-9000"); ;}
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 2615 "cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); ;}
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 2616 "cf-parse.y"
    { init_list(&radv_dns_list); ;}
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 2616 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); ;}
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 2617 "cf-parse.y"
    { init_list(&radv_dns_list); ;}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 2617 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); ;}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 2618 "cf-parse.y"
    { RADV_IFACE->rdnss_local = (yyvsp[(3) - (3)].i); ;}
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 2619 "cf-parse.y"
    { RADV_IFACE->dnssl_local = (yyvsp[(3) - (3)].i); ;}
    break;

  case 640:

/* Line 1455 of yacc.c  */
#line 2623 "cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = _MAX(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
;}
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 2656 "cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[(1) - (1)].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[(1) - (1)].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
;}
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 2668 "cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); ;}
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 2669 "cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); ;}
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 2670 "cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); ;}
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 2671 "cf-parse.y"
    { RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Valid lifetime must be 0 or positive"); ;}
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 2672 "cf-parse.y"
    { RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Preferred lifetime must be 0 or positive"); ;}
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 2676 "cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");
;}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 2697 "cf-parse.y"
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[(1) - (1)].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
;}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 2706 "cf-parse.y"
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
;}
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 2713 "cf-parse.y"
    { RADV_RDNSS->lifetime = (yyvsp[(2) - (2)].i); RADV_RDNSS->lifetime_mult = radv_mult_val; ;}
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 2717 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
;}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 2741 "cf-parse.y"
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[(1) - (1)].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
;}
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 2753 "cf-parse.y"
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
;}
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 2760 "cf-parse.y"
    { RADV_DNSSL->lifetime = (yyvsp[(2) - (2)].i); RADV_DNSSL->lifetime_mult = radv_mult_val; ;}
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 2764 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
;}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 2788 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i); radv_mult_val = 0; ;}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 2789 "cf-parse.y"
    { (yyval.i) = 0; radv_mult_val = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) < 1) || ((yyvsp[(2) - (2)].i) > 254)) cf_error("Multiplier must be in range 1-254"); ;}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 2795 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[(1) - (2)].i));
     rip_init_config(RIP_CFG);
   ;}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 2804 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); ;}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 2805 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); ;}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 2806 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); ;}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 2807 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 2808 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 2809 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); ;}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 2811 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; ;}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 2812 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; ;}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 2813 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; ;}
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 2818 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; ;}
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 2819 "cf-parse.y"
    { (yyval.i)=AT_MD5; ;}
    break;

  case 696:

/* Line 1455 of yacc.c  */
#line 2820 "cf-parse.y"
    { (yyval.i)=AT_NONE; ;}
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 2825 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; ;}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 2826 "cf-parse.y"
    { (yyval.i)=0; ;}
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 2827 "cf-parse.y"
    { (yyval.i)=IM_QUIET; ;}
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 2828 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; ;}
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 2829 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; ;}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 2833 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); ;}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 2834 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); ;}
    break;

  case 709:

/* Line 1455 of yacc.c  */
#line 2848 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   ;}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 2864 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  ;}
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 2873 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); ;}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 2874 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); ;}
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 2878 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  ;}
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 2887 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   ;}
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 2895 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   ;}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 2902 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; ;}
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 2903 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; ;}
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 2907 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   ;}
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 2912 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   ;}
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 2918 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   ;}
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 2921 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   ;}
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 2926 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; ;}
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 2927 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; ;}
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 2928 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; ;}
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 2929 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; ;}
    break;

  case 730:

/* Line 1455 of yacc.c  */
#line 2930 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; ;}
    break;

  case 731:

/* Line 1455 of yacc.c  */
#line 2934 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); ;}
    break;

  case 793:

/* Line 1455 of yacc.c  */
#line 2942 "cf-parse.y"
    { bgp_check_config(BGP_CFG); ;}
    break;

  case 794:

/* Line 1455 of yacc.c  */
#line 2942 "cf-parse.y"
    { ospf_proto_finish(); ;}
    break;

  case 797:

/* Line 1455 of yacc.c  */
#line 2942 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); ;}
    break;

  case 806:

/* Line 1455 of yacc.c  */
#line 2945 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); ;}
    break;

  case 807:

/* Line 1455 of yacc.c  */
#line 2945 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); ;}
    break;

  case 808:

/* Line 1455 of yacc.c  */
#line 2945 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); ;}
    break;

  case 809:

/* Line 1455 of yacc.c  */
#line 2945 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); ;}
    break;

  case 810:

/* Line 1455 of yacc.c  */
#line 2946 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); ;}
    break;

  case 811:

/* Line 1455 of yacc.c  */
#line 2946 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 812:

/* Line 1455 of yacc.c  */
#line 2947 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); ;}
    break;

  case 813:

/* Line 1455 of yacc.c  */
#line 2948 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); ;}
    break;

  case 814:

/* Line 1455 of yacc.c  */
#line 2949 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); ;}
    break;

  case 815:

/* Line 1455 of yacc.c  */
#line 2950 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); ;}
    break;

  case 816:

/* Line 1455 of yacc.c  */
#line 2951 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); ;}
    break;

  case 817:

/* Line 1455 of yacc.c  */
#line 2952 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); ;}
    break;

  case 818:

/* Line 1455 of yacc.c  */
#line 2953 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); ;}
    break;

  case 819:

/* Line 1455 of yacc.c  */
#line 2954 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); ;}
    break;

  case 820:

/* Line 1455 of yacc.c  */
#line 2955 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); ;}
    break;

  case 821:

/* Line 1455 of yacc.c  */
#line 2956 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); ;}
    break;

  case 822:

/* Line 1455 of yacc.c  */
#line 2957 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); ;}
    break;

  case 823:

/* Line 1455 of yacc.c  */
#line 2957 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); ;}
    break;

  case 824:

/* Line 1455 of yacc.c  */
#line 2957 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); ;}
    break;

  case 825:

/* Line 1455 of yacc.c  */
#line 2957 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); ;}
    break;

  case 826:

/* Line 1455 of yacc.c  */
#line 2957 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); ;}
    break;

  case 827:

/* Line 1455 of yacc.c  */
#line 2957 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); ;}
    break;

  case 828:

/* Line 1455 of yacc.c  */
#line 2957 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); ;}
    break;



/* Line 1455 of yacc.c  */
#line 9174 "cf-parse.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 2959 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


